
//  Created by VaxSoft
//  Copyright © 2025 VaxSoft. All rights reserved.

#import <UIKit/UIKit.h>
#import <AddressBook/AddressBook.h>
#import <AddressBookUI/AddressBookUI.h>

@import ContactsUI;
@import Contacts;

@protocol cAddressBookViewDelegate <NSObject>

@optional
- (void) OnAddressBookSelectedPhoneNo :(NSString*) sPhoneNo;
- (void) OnAddressBookSelectedContact :(NSString*) sContactId :(NSString*) sContactTitle;
@end


@interface cAddressBookView : NSObject <CNContactPickerDelegate>
{
    Boolean m_bGranted;
    Boolean m_bAccessOnlyContacts;
    
    CNContactPickerViewController* mAddressBook;
    
    id <cAddressBookViewDelegate> mAddressBookDelegate;
}

@property (retain) id mAddressBookDelegate;

- (id)initWith:(id) iDelegate;
- (void) ShowContacts :(UIViewController*) pParent :(bool) bAccessOnlyContacts;

@end
