
//  Created by VaxSoft
//  Copyright © 2025 VaxSoft. All rights reserved.

#import <AVFoundation/AVFoundation.h>
#import "cVaxBackForeNotify.h"
#import <UIKit/UIKit.h>

@implementation cVaxBackForeNotify
@synthesize mBackForeDelegate;


- (id) initWith :(id) iDelegate;
{
    mBackForeDelegate = iDelegate;
    m_bForeground = true;
    
    self = [super init];
    return self;
}

- (void) dealloc;
{
}

//////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////

- (void) BackForegroundNotify :(Boolean) bEnable;
{
    m_bForeground = true;
    
    [self BackgroundNotify :bEnable];
    [self ForegroundNotify :bEnable];
}

//////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////

- (void) ForegroundNotify :(Boolean) bEnable;
{
    [[NSNotificationCenter defaultCenter] removeObserver:self name:UIApplicationDidBecomeActiveNotification object:nil];
    
    if(bEnable)
    {
        [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(OnApplicationEnterForeground:) name:UIApplicationDidBecomeActiveNotification object:nil];
    }
}

- (void) BackgroundNotify :(Boolean) bEnable;
{
    [[NSNotificationCenter defaultCenter] removeObserver:self name:UIApplicationWillResignActiveNotification object:nil];
    
    if(bEnable)
    {
        [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(OnApplicationEnterBackground:) name:UIApplicationWillResignActiveNotification object:nil];
    }
}

//////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////

- (void) OnApplicationEnterForeground :(NSNotification*) note;
{
    if(m_bForeground == true)
        return;
    
    m_bForeground = true;
    
    if (![mBackForeDelegate respondsToSelector:@selector(OnVaxApplicationEnterForeground)])
        return;
    
    [mBackForeDelegate OnVaxApplicationEnterForeground];
}

- (void) OnApplicationEnterBackground :(NSNotification*) note;
{
    if(m_bForeground == false)
        return;
    
    m_bForeground = false;
    
    if (![mBackForeDelegate respondsToSelector:@selector(OnVaxApplicationEnterBackground)])
        return;
        
    [mBackForeDelegate OnVaxApplicationEnterBackground];
}

@end
