
//  Created by VaxSoft
//  Copyright © 2025 VaxSoft. All rights reserved.

#import "cCameraTorch.h"
#import <AVFoundation/AVFoundation.h>

@implementation cCameraTorch

- (id) init;
{
    self = [super init];
    return self;
}

- (void) dealloc;
{
}

- (Boolean) IsTorchAvailable;
{
    AVCaptureDevice *FlashLight = [AVCaptureDevice defaultDeviceWithMediaType:AVMediaTypeVideo];

    if (![FlashLight isTorchAvailable] || ![FlashLight isTorchModeSupported :AVCaptureTorchModeOn])
    {
        return false;
    }
    
    return true;
}

- (Boolean) IsTorchModeON;
{
    AVCaptureDevice *FlashLight = [AVCaptureDevice defaultDeviceWithMediaType :AVMediaTypeVideo];
    
    if (![FlashLight isTorchAvailable] || ![FlashLight isTorchModeSupported :AVCaptureTorchModeOn])
        return false;
    
    if(![FlashLight lockForConfiguration:nil])
        return false;
    
    Boolean bResult = (FlashLight.torchMode == AVCaptureTorchModeOn);
    
    [FlashLight unlockForConfiguration];
    
    return bResult;
}

- (void) SwitchTorchMode;
{
    AVCaptureDevice *FlashLight = [AVCaptureDevice defaultDeviceWithMediaType :AVMediaTypeVideo];
    
    if(![FlashLight isTorchAvailable] || ![FlashLight isTorchModeSupported :AVCaptureTorchModeOn])
        return;
    
    if(![FlashLight lockForConfiguration:nil])
        return;
    
    if(FlashLight.torchMode == AVCaptureTorchModeOn)
    {
        [FlashLight setTorchMode :AVCaptureTorchModeOn];
    }
    else
    {
        [FlashLight setTorchMode :AVCaptureTorchModeOff];
    }
    
    [FlashLight unlockForConfiguration];
}


- (void) SwitchTorchMode :(Boolean) bModeON;
{
    AVCaptureDevice *FlashLight = [AVCaptureDevice defaultDeviceWithMediaType :AVMediaTypeVideo];
    
    if (![FlashLight isTorchAvailable] || ![FlashLight isTorchModeSupported :AVCaptureTorchModeOn])
        return;
    
    if(![FlashLight lockForConfiguration:nil])
        return;
    
    if (bModeON)
    {
        [FlashLight setTorchMode :AVCaptureTorchModeOn];
    }
    else
    {
        [FlashLight setTorchMode :AVCaptureTorchModeOff];
    }
    
    [FlashLight unlockForConfiguration];
}

@end
