
//  Created by VaxSoft
//  Copyright © 2025 VaxSoft. All rights reserved.

#import <Foundation/Foundation.h>
#import <AVFoundation/AVFoundation.h>

#import "cVaxPhoneDTMF.h"
#import "cPlayDTMF.h"

#import "cSettingDigitDTMFTableView.h"

static cVaxPhoneDTMF* mSelf = NULL;

@implementation cVaxPhoneDTMF

- (id) init;
{
    m_nTypeDTMF = VAX_DTMF_TYPE_AUTO;
    
    self = [super init];
    mSelf = self;
    
    mVaxAgentSIP = [[cVaxUserAgentSIP alloc] initWith :self];
    mpPlayDTMF = [cPlayDTMF new];
    
    return self;
}

- (void) dealloc;
{
    mpPlayDTMF = NULL;
    mVaxAgentSIP = NULL;
}

+ (cVaxPhoneDTMF*) GetSelf;
{
    return mSelf;
}

/////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////

- (bool) PlayDTMF :(NSString*) sDigit;
{
    [mpPlayDTMF PlayTone :sDigit];
    return [mVaxAgentSIP DigitDTMF :0 :sDigit :m_nTypeDTMF];
}

- (void) ForceDigitDTMF :(int) nTypeId :(bool) bEnable;
{
    m_nTypeDTMF = nTypeId;
}

/////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////

- (void) OnInitialized;
{
    [cSettingDigitDTMFTableView PostInitialize];
    
    [[AVAudioSession sharedInstance] setCategory:AVAudioSessionCategoryPlayback withOptions:AVAudioSessionCategoryOptionMixWithOthers error: nil];
}

- (void) OnDigitDTMF :(NSString*) sAccountName :(int) nLineNo :(NSString*) sDigit;
{
    
}

- (void) OnHungupCall :(NSString*) sAccountName :(int) nLineNo;
{
    if([mVaxAgentSIP IsLineBusy: -1])
        return;
    
   [[AVAudioSession sharedInstance] setCategory:AVAudioSessionCategoryPlayback withOptions:AVAudioSessionCategoryOptionMixWithOthers error: nil];
}

- (void) OnDisconnectedCall :(int) nLineNo;
{
    if([mVaxAgentSIP IsLineBusy: -1])
        return;
    
   [[AVAudioSession sharedInstance] setCategory:AVAudioSessionCategoryPlayback withOptions:AVAudioSessionCategoryOptionMixWithOthers error: nil];
}

/////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////

@end
