
//  Created by VaxSoft
//  Copyright © 2025 VaxSoft. All rights reserved.

#import <UIKit/UIAlertView.h>
#import "cVaxPhoneCodec.h"

#import "cSettingVoiceCodecTableView.h"
#import "cSettingVideoCodecTableView.h"

static cVaxPhoneCodec* mSelf = NULL;

@implementation cVaxPhoneCodec

- (id) init;
{
    self = [super init];
    mSelf = self;
    
    mVaxAgentSIP = [[cVaxUserAgentSIP alloc] initWith :self];
    return self;
}

- (void) dealloc;
{
    mVaxAgentSIP = NULL;
}

+ (cVaxPhoneCodec*) GetSelf;
{
    return mSelf;
}

/////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////

- (Boolean) ActivateAudioCodec :(Boolean) bEnable :(int) nCodecNo;
{
    if(nCodecNo == -1)
    {
        if(bEnable)
            [mVaxAgentSIP SelectAllAudioCodec];
        else
            [mVaxAgentSIP DeselectAllAudioCodec];
        
        return true;
    }
    
    if(bEnable)
        return [mVaxAgentSIP SelectAudioCodec :nCodecNo];
    
    return [mVaxAgentSIP DeselectAudioCodec :nCodecNo];
}

- (Boolean) ActivateVideoCodec :(Boolean) bEnable :(int) nCodecNo;
{
    if(nCodecNo == -1)
    {
        if(bEnable)
            [mVaxAgentSIP SelectAllVideoCodec];
        else
            [mVaxAgentSIP DeselectAllVideoCodec];
        
        return true;
    }
    
    if(bEnable)
        return [mVaxAgentSIP SelectVideoCodec :nCodecNo];
    
    return [mVaxAgentSIP DeselectVideoCodec :nCodecNo];
}

/////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////

- (void) OnInitialized;
{
    [cSettingVideoCodecTableView PostInitialize];
    [cSettingVoiceCodecTableView PostInitialize];
}

@end
