
//  Created by VaxSoft
//  Copyright © 2025 VaxSoft. All rights reserved.

#import <UIKit/UIAlertView.h>
#import "cVaxPhoneLog.h"

static cVaxPhoneLog* mSelf = NULL;

@implementation cVaxPhoneLog

- (id) init;
{
    self = [super init];
    mSelf = self;
    
    mVaxAgentSIP = [[cVaxUserAgentSIP alloc] initWith :self];
    
    m_sLogFile = NULL;
    return self;
}

- (void) dealloc;
{
    m_sLogFile = NULL;
    mVaxAgentSIP = NULL;
}

+ (cVaxPhoneLog*) GetSelf;
{
    return mSelf;
}

/////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////

- (void) DiagnosticLog:(Boolean) bEnable;
{
    if(bEnable)
    {
        m_sLogFile = [NSMutableString new];
        
        NSArray* aPaths = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES);
        NSString* sFolder = [aPaths objectAtIndex: 0];
        NSString* sFileName = [sFolder stringByAppendingPathComponent: @"VaxLog.txt"];
        
        [m_sLogFile setString: sFileName];
    }
    else
    {
        m_sLogFile = NULL;
    }
    
    [mVaxAgentSIP DiagnosticLogSIP :@"" :bEnable :bEnable];
}

- (void) WriteToLogFile :(const char*) pText;
{
    if(m_sLogFile == NULL)
        return;
    
    u_long nDataSize = strlen(pText);
    if(nDataSize == 0) return;
    
    FILE* fp = fopen([m_sLogFile UTF8String], "ab");
    
    fwrite(pText, sizeof(char), nDataSize, fp);
    fclose(fp);
}

/////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////

- (void) OnIncomingDiagnostic :(NSString*) sAccountName :(NSString*) sMsgSIP :(NSString*) sFromIP :(int) nFromPort;
{
    if(m_sLogFile == NULL)
        return;
    
    NSString* sLogPacket = [NSString stringWithFormat: @"Received: %@:%d\n%@\n", sFromIP, nFromPort, sMsgSIP];
    [self WriteToLogFile: [sLogPacket UTF8String]];
}

- (void) OnOutgoingDiagnostic :(NSString*) sAccountName :(NSString*) sMsgSIP :(NSString*) sToIP :(int) nToPort;
{
    if(m_sLogFile == NULL)
        return;
    
    NSString* sLogPacket = [NSString stringWithFormat: @"Sent: %@:%d\n%@\n", sToIP, nToPort, sMsgSIP];
    [self WriteToLogFile: [sLogPacket UTF8String]];
}

/////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////

@end
