
//  Created by VaxSoft
//  Copyright © 2025 VaxSoft. All rights reserved.

#import <UIKit/UIAlertView.h>
#import "cVaxPhoneMicSpk.h"

#import "cSettingMicSpkTableView.h"

static cVaxPhoneMicSpk* mSelf = NULL;

@implementation cVaxPhoneMicSpk

- (id) init;
{
    m_bMuteMic = false;
    m_bMuteSpk = false;
    
    self = [super init];
    mSelf = self;
    
    mVaxAgentSIP = [[cVaxUserAgentSIP alloc] initWith :self];
    return self;
}

- (void) dealloc;
{
    mVaxAgentSIP = NULL;
}

+ (cVaxPhoneMicSpk*) GetSelf;
{
    return mSelf;
}

/////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////

- (bool) AutoGainSpk :(bool) bEnable;
{
    return [mVaxAgentSIP AutoGainSpk :bEnable :20];
}

- (bool) AutoGainMic :(bool) bEnable;
{
    return [mVaxAgentSIP AutoGainMic :bEnable :20];
}

- (bool) SetVolumeBoostMic :(Boolean) bEnable;
{
    int nBoostVol = 0;
    
    if(bEnable)
        nBoostVol = 20;
    
    return [mVaxAgentSIP SetVolumeMic :nBoostVol];
}

/////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////

- (bool) IsMuteMic;
{
    return m_bMuteMic;
}

- (bool) MuteMic :(bool) bMute;
{
    if(![mVaxAgentSIP MuteMic :bMute])
        return false;
    
    m_bMuteMic = bMute;
    return true;
}

- (bool) IsMuteSpk;
{
    return m_bMuteSpk;
}

- (bool) MuteSpk :(bool) bMute;
{
    if(![mVaxAgentSIP MuteSpk :bMute])
        return false;
    
    m_bMuteSpk = bMute;
    return true;
}

/////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////

- (void) OnInitialized;
{
    [cSettingMicSpkTableView PostInitialize];
}

@end
