
//  Created by VaxSoft
//  Copyright © 2025 VaxSoft. All rights reserved.

#import <UIKit/UIAlertView.h>
#import "cVaxPhoneStatus.h"

#import "cMsgAlert.h"
#import "cVideoView.h"
#import "cAccountLoginView.h"

@implementation cVaxPhoneStatus

- (id) init;
{
    m_bVideoCaptureErrorShown = false;
    
    self = [super init];
    
    mVaxAgentSIP = [[cVaxUserAgentSIP alloc] initWith :self];
    return self;
}

- (void) dealloc;
{
    mVaxAgentSIP = NULL;
}

/////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////

- (void) OnInitialized;
{
    NSString* sMsgText = @"Account is online";
    
    [cAccountLoginView PostStatusText :sMsgText];
    [cVideoView PostStatusText :sMsgText];
}

- (void) OnUnInitialized;
{
    m_bVideoCaptureErrorShown = false;
    
    NSString* sMsgText = @"Account is offline";
    
    [cAccountLoginView PostStatusText :sMsgText];
    [cVideoView PostStatusText :sMsgText];
}

/////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////

- (void) OnConnectingToRegister :(NSString*) sAccountName;
{
    [cAccountLoginView PostStatusText :@"Trying to connect"];
    [cVideoView PostStatusText :@"Register: Trying to connect"];
}

- (void) OnTryingToRegister :(NSString*) sAccountName;
{
    NSString* sMsgText = @"Registering Account";
    
    [cAccountLoginView PostStatusText :sMsgText];
    [cVideoView PostStatusText :sMsgText];
}

- (void) OnFailToRegister :(NSString*) sAccountName :(int) nStatusCode :(NSString*) sReasonPhrase;
{
    NSString* sMsgText = [NSString stringWithFormat: @"Register: %@", sReasonPhrase];
    
    [cAccountLoginView PostStatusText :sMsgText];
    [cVideoView PostStatusText :sMsgText];
}

- (void) OnSuccessToRegister :(NSString*) sAccountName;
{
    NSString* sMsgText = @"Account Registered";
    
    [cAccountLoginView PostStatusText :sMsgText];
    [cVideoView PostStatusText :sMsgText];
}

/////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////

- (void) OnConnectingToReRegister :(NSString*) sAccountName;
{
}

- (void) OnTryingToReRegister :(NSString*) sAccountName;
{
}

- (void) OnFailToReRegister :(NSString*) sAccountName :(int) nStatusCode :(NSString*) sReasonPhrase;
{
    NSString* sMsgText = [NSString stringWithFormat: @"Re-Register: %@", sReasonPhrase];
    
    [cAccountLoginView PostStatusText :sMsgText];
    [cVideoView PostStatusText :sMsgText];
}

- (void) OnSuccessToReRegister :(NSString*) sAccountName;
{
}

/////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////

- (void) OnTryingToUnRegister :(NSString*) sAccountName;
{
    [cAccountLoginView PostStatusText :@"Un-Registering Account"];
}

- (void) OnFailToUnRegister :(NSString*) sAccountName;
{
    NSString* sMsgText = [NSString stringWithFormat: @"Un-Register: %@", @"Failed"];
    [cAccountLoginView PostStatusText :sMsgText];
}

- (void) OnSuccessToUnRegister :(NSString*) sAccountName;
{
    [cAccountLoginView PostStatusText :@"Account Un-Registered"];
}

/////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////

- (void) OnDialCallStarted :(NSString*) sAccountName :(int) nLineNo :(NSString*) sCallerName :(NSString*) sCallerId :(NSString*) sDialNo;
{
    [cVideoView PostStatusText :@"Call: Connecting"];
}

- (void) OnDialingCall :(NSString*) sAccountName :(int) nLineNo :(int) nStatusCode :(NSString*) sReasonPhrase;
{
    [cVideoView PostStatusText :@"Call: Dialing"];
}

- (void) OnDialCallFailed :(NSString*) sAccountName :(int) nLineNo :(int) nStatusCode :(NSString*) sReasonPhrase :(NSString*) sContact;
{
    NSString* sMsgText = [NSString stringWithFormat: @"Call: %@", sReasonPhrase];
    [cVideoView PostStatusText :sMsgText];
}

/////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////

- (void) OnConnectedCall :(NSString*) sAccountName :(int) nLineNo;
{
    [cVideoView PostStatusText :@"Call: Connected"];
}

- (void) OnDisconnectedCall :(int) nLineNo;
{
    [cVideoView PostStatusText :@"Call: Disconnected"];
}

- (void) OnHungupCall :(NSString*) sAccountName :(int) nLineNo;
{
    [cVideoView PostStatusText :@"Call: Hungup"];
}

/////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////

- (void) OnTransferCallAccepted :(NSString*) sAccountName :(int) nLineNo;
{
    [cVideoView PostStatusText :@"Transfer: Accepted"];
}

- (void) OnTransferCallFailed :(NSString*) sAccountName :(int) nLineNo :(int) nStatusCode :(NSString*) sReasonPhrase;
{
    NSString* sMsgText = [NSString stringWithFormat: @"Transfer: %@", sReasonPhrase];
    [cVideoView PostStatusText :sMsgText];
}

/////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////

- (void) OnSuccessToHold :(NSString*) sAccountName :(int) nLineNo;
{
    [cVideoView PostStatusText :@"Hold: Successful"];
}

- (void) OnTryingToHold :(NSString*) sAccountName :(int) nLineNo;
{
    [cVideoView PostStatusText :@"Hold: Trying"];
}

- (void) OnFailToHold :(NSString*) sAccountName :(int) nLineNo;
{
    [cVideoView PostStatusText :@"Hold: Failed"];
}

- (void) OnSuccessToUnHold :(NSString*) sAccountName :(int) nLineNo;
{
    [cVideoView PostStatusText :@"UnHold: Successful"];
}

- (void) OnTryingToUnHold :(NSString*) sAccountName :(int) nLineNo;
{
    [cVideoView PostStatusText :@"UnHold: Trying"];
}

- (void) OnFailToUnHold :(NSString*) sAccountName :(int) nLineNo;
{
    [cVideoView PostStatusText :@"UnHold: Failed"];
}

/////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////

- (void) OnNetworkReachability :(Boolean) bAvailable;
{
    if(bAvailable)
    {
        [cAccountLoginView PostStatusText :@"Network is available"];
        [cVideoView PostStatusText :@"Network is available"];
    }
    else
    {
        [cAccountLoginView PostStatusText :@"Network is not available"];
        [cVideoView PostStatusText :@"Network is not available"];
    }
}

/////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////

- (void) OnVaxErrorMsg :(NSString*) sFuncName :(NSString*) sErrorMsg :(int) nErrorCode;
{
    if([sFuncName isEqualToString :@"OpenVideoDev"])
    {
        if(m_bVideoCaptureErrorShown)
            return;
        
        m_bVideoCaptureErrorShown = true;
    }
    
    [cMsgAlert ShowAlert :sErrorMsg];
}

/////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////

- (void) OnVaxRegisterTryingPushKit;
{
    NSString* sMsgText = @"PushKit: Register Trying";
        
    [cAccountLoginView PostStatusText :sMsgText];
    [cVideoView PostStatusText :sMsgText];
}

- (void) OnVaxRegisterFailedPushKit;
{
    NSString* sMsgText = @"PushKit: Register Failed";
        
    [cAccountLoginView PostStatusText :sMsgText];
    [cVideoView PostStatusText :sMsgText];
}

/////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////

- (void) OnTryingToRefresh :(NSString*) sAccountName :(int) nLineNo;
{
    
}

- (void) OnFailToRefresh :(NSString*) sAccountName :(int) nLineNo;
{
    
}

- (void) OnSuccessToRefresh :(NSString*) sAccountName :(int) nLineNo;
{
    
}

/////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////

@end

