
//  Created by VaxSoft
//  Copyright © 2025 VaxSoft. All rights reserved.

#import <Foundation/Foundation.h>
#import "cVaxUserAgentSIP.h"
#import "cIncomingCallAlert.h"

#import "cVaxCallKit.h"
#import "cVaxBackForeNotify.h"

#import "cVaxPhoneCodec.h"
#import "cVaxPhoneDTMF.h"
#import "cVaxPhoneRing.h"
#import "cVaxPhoneLog.h"
#import "cVaxPhoneVideo.h"
#import "cVaxPhoneChat.h"
#import "cVaxPhoneStatus.h"
#import "cVaxPhoneVoiceChanger.h"
#import "cVaxPhoneMicSpk.h"
#import "cVaxPhoneGeneral.h"

#define ACCOUNT_VAXVOIP        @"VaxAccountSIP"

@class cVaxBackForeNotify;

@interface cVaxPhoneSIP : NSObject <iVaxUserAgentSIP, iVaxCallKit, iIncomingCallAlert, iVaxBackForeNotify>
{
    Boolean m_bOnline;
    Boolean m_bRegistrationSIP;
    
    cVaxUserAgentSIP* mVaxAgentSIP;
    
    cIncomingCallAlert* mIncomingCallAlert;
    cVaxBackForeNotify* mBackForeNotify;
    
    cVaxPhoneGeneral* mVaxPhoneGeneral;
    cVaxPhoneCodec* mVaxPhoneCodec;
    cVaxPhoneDTMF* mVaxPhoneDTMF;
    cVaxPhoneRing* mVaxPhoneRing;
    cVaxPhoneLog* mVaxPhoneLog;
    cVaxPhoneVideo* mVaxPhoneVideo;
    cVaxPhoneChat* mVaxPhoneChat;
    cVaxPhoneStatus* mVaxPhoneStatus;
    cVaxPhoneMicSpk* mVaxPhoneMicSpk;
    cVaxPhoneVoiceChanger* mVaxPhoneVoiceChanger;
    
    cVaxCallKit* mCallKit;
}

- (id) init;
- (void) dealloc;

+ (cVaxPhoneSIP*) GetSelf;

- (bool) Initialize;
- (void) UnInitialize;
- (Boolean) IsOnline;

- (Boolean) DialCall :(NSString*) sDialNo;
- (Boolean) DisconnectCall;

@end
