
//  Created by VaxSoft
//  Copyright © 2025 VaxSoft. All rights reserved.

#import "cVaxPhoneSIP.h"
#import "cChatMyStatusTableView.h"
#import "cChatMyStatusRowView.h"
#import "cVaxPhoneSIP.h"

#define SECTION_TOTAL_COUNT          1
#define ROW_TOTAL_COUNT              5

#define SECTION_ID_MY_STATUS         0

static long m_nChatMyStatusTableView_StatusId = VAX_CONTACT_STATUS_ONLINE;

@interface cChatMyStatusTableView ()
@end

@implementation cChatMyStatusTableView

- (void) viewDidLoad
{
    [super viewDidLoad];
}

- (void) didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
}

//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////

+ (void) PostInitialize;
{
    [[cVaxPhoneChat GetSelf] ChatSetMyStatus: (int) m_nChatMyStatusTableView_StatusId];
}

//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////

#pragma mark - Table view data source

- (NSInteger) numberOfSectionsInTableView :(UITableView *)tableView
{
    return SECTION_TOTAL_COUNT;
}

- (NSInteger) tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section
{
    return ROW_TOTAL_COUNT;
}

//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////

- (UITableViewCell *) tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath
 {
     Boolean bSelected = false;
     
     if(m_nChatMyStatusTableView_StatusId == indexPath.row)
         bSelected = true;
     
     cChatMyStatusRowView* pRowView = NULL;
     
     if(indexPath.row == VAX_CONTACT_STATUS_ONLINE && indexPath.section == SECTION_ID_MY_STATUS)
     {
         pRowView = [tableView dequeueReusableCellWithIdentifier:@"ChatStatusOnlineCellId" forIndexPath:indexPath];
     }
     
     else if(indexPath.row == VAX_CONTACT_STATUS_OFFLINE && indexPath.section == SECTION_ID_MY_STATUS)
     {
         pRowView = [tableView dequeueReusableCellWithIdentifier:@"ChatStatusOfflineCellId" forIndexPath:indexPath];
     }
     
     else if(indexPath.row == VAX_CONTACT_STATUS_AWAY && indexPath.section == SECTION_ID_MY_STATUS)
     {
         pRowView = [tableView dequeueReusableCellWithIdentifier:@"ChatStatusAwayCellId" forIndexPath:indexPath];
     }
     
     else if(indexPath.row == VAX_CONTACT_STATUS_ON_PHONE && indexPath.section == SECTION_ID_MY_STATUS)
     {
         pRowView = [tableView dequeueReusableCellWithIdentifier:@"ChatStatusOnPhoneCellId" forIndexPath:indexPath];
     }
     else
     {
         pRowView = [tableView dequeueReusableCellWithIdentifier:@"ChatStatusBusyCellId" forIndexPath:indexPath];
     }
     
     [pRowView SetSelected :bSelected];
     return pRowView;
}

//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////

- (void) tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath
{
    for(int nRowNo = 0; nRowNo < ROW_TOTAL_COUNT; nRowNo++)
    {
        cChatMyStatusRowView* pRowView = (cChatMyStatusRowView*) [self.tableView cellForRowAtIndexPath: [NSIndexPath indexPathForRow: nRowNo inSection: SECTION_ID_MY_STATUS]];
        if(pRowView != nil) [pRowView SetSelected :NO];
    }
    
    cChatMyStatusRowView* pRowView = (cChatMyStatusRowView*) [self.tableView cellForRowAtIndexPath: indexPath];
    if(pRowView != nil) [pRowView SetSelected :YES];
    
    m_nChatMyStatusTableView_StatusId = indexPath.row;
    [[cVaxPhoneChat GetSelf] ChatSetMyStatus: (int) m_nChatMyStatusTableView_StatusId];
    
    [self performSegueWithIdentifier: @"UnwindSegueToChatContact" sender: self];
}

//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////

@end
