
//  Created by VaxSoft
//  Copyright © 2025 VaxSoft. All rights reserved.

#import "cVaxPhoneSIP.h"
#import "cChatContactRowView.h"

@implementation cChatContactRowView

- (void)awakeFromNib
{
    [super awakeFromNib];
}

- (void)setSelected :(BOOL)selected animated:(BOOL)animated
{
    [super setSelected:selected animated:animated];
}

- (void) SetData :(cChatContactRowData*) pRowData;
{
    m_pRowData = pRowData;
    
    [self UpdateLabelContactName];
    [self UpdateContactStatus];
}

- (NSString*) GetContactName;
{
    return [m_pRowData GetContactName];
}

- (void) UpdateContactStatus;
{
    long nStatusId = [m_pRowData GetStatusId];
    
    if(nStatusId == VAX_CONTACT_STATUS_ONLINE)
    {
        [mImageContactStatus setImage :[UIImage imageNamed: @"aChatOnline"]];
        [mLabelContactStatus setText :@"(Online)"];
    }
    
    else if(nStatusId == VAX_CONTACT_STATUS_OFFLINE)
    {
        [mImageContactStatus setImage :[UIImage imageNamed: @"aChatOffline"]];
        [mLabelContactStatus setText :@"(Offline)"];
    }
    
    else if(nStatusId == VAX_CONTACT_STATUS_UNKNOWN)
    {
        [mImageContactStatus setImage :[UIImage imageNamed: @"aChatUnknown"]];
        [mLabelContactStatus setText :@""];
    }
    
    else if(nStatusId == VAX_CONTACT_STATUS_BUSY || nStatusId == VAX_CONTACT_STATUS_ON_PHONE)
    {
        [mImageContactStatus setImage :[UIImage imageNamed: @"aChatBusy"]];
        [mLabelContactStatus setText :@"(Busy)"];
    }
    
    else if(nStatusId == VAX_CONTACT_STATUS_AWAY)
    {
        [mImageContactStatus setImage :[UIImage imageNamed: @"aChatAway"]];
        [mLabelContactStatus setText :@"(Away)"];
    }
    
    else
    {
        [mImageContactStatus setImage :[UIImage imageNamed: @"aChatOffline"]];
        [mLabelContactStatus setText :@"(Offline)"];
    }
}

- (void) UpdateContactMissedCount;
{
    [self UpdateLabelContactName];
}

- (void) UpdateLabelContactName;
{
    long nMissedCount = [m_pRowData GetMissedCount];
    
    if(nMissedCount == 0)
    {
        [mLabelContactName setText :[m_pRowData GetContactName]];
        [mLabelContactName setTextColor: [UIColor blackColor]];
    }
    else
    {
        NSString* sContactLable = [NSString stringWithFormat :@"%@ [%ld]", [m_pRowData GetContactName], nMissedCount];
        
        [mLabelContactName setText :sContactLable];
        [mLabelContactName setTextColor: [UIColor redColor]];
    }
}

@end
