
//  Created by VaxSoft
//  Copyright © 2025 VaxSoft. All rights reserved.

#import "cChatMsgContainerView.h"
#import "cVaxPhoneSIP.h"

static NSMutableString* m_sChatMsgContainerView_ContactName = nil;
static NSMutableString* m_sChatMsgContainerView_NewContactMsg = nil;

@interface cChatMsgContainerView ()
@end

@implementation cChatMsgContainerView

- (void) viewDidLoad
{
    [mSendChatMsgText setDelegate :self];
    [super viewDidLoad];
}

- (void) didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
}

//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////

+ (void) PostMessageViewData :(NSString*) sContactName :(Boolean) bPresence :(NSString*) sMsgText;
{
    [cChatMsgTableView PostMessageViewData :sContactName :bPresence];
    
    m_sChatMsgContainerView_ContactName = [NSMutableString new];
    [m_sChatMsgContainerView_ContactName setString: sContactName];
    
    m_sChatMsgContainerView_NewContactMsg = [NSMutableString new];
    [m_sChatMsgContainerView_NewContactMsg setString :sMsgText];
}

//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////

- (void) viewWillAppear :(BOOL)animated
{
    [[NSNotificationCenter defaultCenter] addObserver:self selector :@selector(keyboardWillShow:) name:UIKeyboardWillShowNotification object :self.view.window];
    [[NSNotificationCenter defaultCenter] addObserver:self selector :@selector(keyboardWillHide:) name:UIKeyboardWillHideNotification object :self.view.window];
    [[NSNotificationCenter defaultCenter] addObserver:self selector :@selector(keyboardDidShow:) name:UIKeyboardDidShowNotification object :self.view.window];
    
    if(m_sChatMsgContainerView_NewContactMsg != nil && [m_sChatMsgContainerView_NewContactMsg length] != 0)
        [mSendChatMsgText setText :m_sChatMsgContainerView_NewContactMsg];

    [super viewWillAppear :animated];
}

- (void) viewDidAppear :(BOOL)animated
{
    mWndFrame = self.view.window.frame;
    [super viewDidAppear :animated];
}

- (void)viewWillDisappear :(BOOL)animated
{
    [self ResetView];
   
    [[NSNotificationCenter defaultCenter] removeObserver :self name :UIKeyboardWillShowNotification object :nil];
    [[NSNotificationCenter defaultCenter] removeObserver :self name :UIKeyboardWillHideNotification object :nil];
    [[NSNotificationCenter defaultCenter] removeObserver :self name :UIKeyboardDidShowNotification object :nil];
    
    m_sChatMsgContainerView_ContactName = nil;
    m_sChatMsgContainerView_NewContactMsg = nil;
    
    [super viewWillDisappear :animated];
}

//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////

- (void) keyboardWillHide:(NSNotification *)notification
{
    NSDictionary* info = [notification userInfo];
    CGRect KeyBoardFrame = [[info objectForKey:UIKeyboardFrameEndUserInfoKey] CGRectValue];
    
    CGRect WndFrame = self.view.window.frame;
    mWndFrame = CGRectMake(0, 0, KeyBoardFrame.size.width, KeyBoardFrame.origin.y);
    
    WndFrame = CGRectMake(0, 0, KeyBoardFrame.size.width, KeyBoardFrame.origin.y);
    self.view.window.frame = WndFrame;
}

- (void) keyboardWillShow:(NSNotification *)notification
{
    NSDictionary* info = [notification userInfo];
    CGRect KeyBoardFrame = [[info objectForKey:UIKeyboardFrameEndUserInfoKey] CGRectValue];

    int nHeightTabBar = self.tabBarController.tabBar.frame.size.height;
    
    CGRect WndFrame = self.view.window.frame;
    mWndFrame = CGRectMake(0, 0, KeyBoardFrame.size.width, KeyBoardFrame.size.height + KeyBoardFrame.origin.y);
    
    WndFrame = CGRectMake(0, 0, KeyBoardFrame.size.width, KeyBoardFrame.origin.y + nHeightTabBar);
    self.view.window.frame = WndFrame;
}

- (void) keyboardDidShow:(NSNotification *)notification
{
    [cChatMsgTableView PostScrollToBottom];
}

- (BOOL) textFieldShouldReturn:(UITextField *)textField
{
    [mSendChatMsgText resignFirstResponder];
    return YES;
}

//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////

- (void) ResetView;
{
    self.view.window.frame = mWndFrame;
}

//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////

- (IBAction) OnClickClearBtn:(id)sender
{
    [cChatMsgTableView PostClearMsgAll];
}

- (IBAction) OnClickSendBtn :(id)sender
{
    if(mSendChatMsgText.text.length == 0 || [m_sChatMsgContainerView_ContactName length] == 0)
        return;
    
    if(![[cVaxPhoneChat GetSelf] ChatSendMessageText :m_sChatMsgContainerView_ContactName :mSendChatMsgText.text])
      return;
    
    mSendChatMsgText.text = @"";
}

@end
