
//  Created by VaxSoft
//  Copyright © 2025 VaxSoft. All rights reserved.

#import "cChatMsgRowView.h"
#import "cChatMsgRowData.h"

@implementation cChatMsgRowView

- (void) awakeFromNib
{
    if(mLabelIncomingMsg != nil)
        mLabelIncomingMsg.hidden = false;
    
    if(mBubbleIncomingMsg != nil)
        mBubbleIncomingMsg.hidden = false;
    
    if(mLabelOutgoingMsg != nil)
        mLabelOutgoingMsg.hidden = false;
    
    if(mBubbleOutgoingMsg != nil)
        mBubbleOutgoingMsg.hidden = false;
    
    [super awakeFromNib];
}

- (void)setSelected:(BOOL)selected animated:(BOOL)animated
{
    [super setSelected:selected animated:animated];
}

- (void) SetData :(cChatMsgRowData*) pRowData;
{
    m_pRowData = pRowData;
    
    NSString* sTextMsg = [pRowData GetChatMsgText];
    m_bMsgTypeOutgoing = [pRowData IsChatMsgTypeOutgoing];
    
    if(m_bMsgTypeOutgoing)
        [self SetOutgingMsg :sTextMsg];
    else
        [self SetIncomingMsg :sTextMsg];
}

- (void) SetIncomingMsg :(NSString*) sTextMsg;
{
    mLabelIncomingMsg.text = sTextMsg;
}

- (void) SetOutgingMsg :(NSString*) sTextMsg;
{
    mLabelOutgoingMsg.text = sTextMsg;
}

@end
