
//  Created by VaxSoft
//  Copyright © 2025 VaxSoft. All rights reserved.

#import "cCustomCellCheckBox.h"

@implementation cCustomCellCheckBox
@synthesize mCheckBoxDelegate;

- (void) dealloc
{
    
}

- (void) LoadCheckBox :(id) iDelegate :(NSString*) sImageON :(NSString*) sImageOFF;
{
    mCheckBoxDelegate = iDelegate;
    
    mImageON = [UIImage imageNamed: sImageON];
    mImageOFF = [UIImage imageNamed: sImageOFF];
    
    [self SetState :false];
    [self addTarget:self action:@selector(OnClickCustomCheckBoxTouchDown:) forControlEvents:UIControlEventTouchDown];
}

- (void) SetSize:  (int) nWidth :(int) nHeight;
{
    CGRect frame = self.frame;
    
    frame.size.width = nWidth;
    frame.size.height = nHeight;
    
    self.frame = frame;
}

- (Boolean) GetState;
{
    return m_bStateON;
}

- (void) SetState :(Boolean) bStateON;
{
    m_bStateON = bStateON;
    
    UIImage* pCheckBoxImage = mImageOFF;
    
    if(bStateON)
    {
        pCheckBoxImage = mImageON;
    }
    
    [self setImage:pCheckBoxImage forState: UIControlStateNormal];
}

- (void) ToggleState;
{
    if([self GetState])
        [self SetState: false];
    else
        [self SetState: true];
}

- (IBAction) OnClickCustomCheckBoxTouchDown :(id) sender;
{
    [self ToggleState];
    
    if(mCheckBoxDelegate == NULL)
        return;
    
    if (![mCheckBoxDelegate respondsToSelector :@selector(OnClickCustomCellCheckBox::)])
        return;
    
    [mCheckBoxDelegate OnClickCustomCellCheckBox :m_bStateON :self];
}

@end
