
//  Created by VaxSoft
//  Copyright © 2025 VaxSoft. All rights reserved.

#import "cCustomTextField.h"

@implementation cCustomTextField

- (void) EnableKeyboardReturnKey;
{
    self.delegate = self;
}

- (BOOL) textFieldShouldReturn:(UITextField *)theTextField
{
    if (theTextField == self)
    {
        [theTextField resignFirstResponder];
    }
    
    return YES;
}

- (void) DeleteText;
{
    if([self.text length] <= 0) return;
    [self setText: [self.text substringToIndex: [self.text length] - 1]];
}

- (void) OnClearText;
{
    [NSObject cancelPreviousPerformRequestsWithTarget:self selector:@selector(OnClearText) object:nil];
    [self performSelector :@selector(OnClearText) withObject:nil afterDelay:0.04];
    
    [self DeleteText];
}

- (void) ClearTextStop;
{
    [NSObject cancelPreviousPerformRequestsWithTarget:self selector:@selector(OnClearText) object:nil];
    [self DeleteText];
}

- (void) ClearTextStart;
{
    [NSObject cancelPreviousPerformRequestsWithTarget:self selector:@selector(OnClearText) object:nil];
    [self performSelector :@selector(OnClearText) withObject:nil afterDelay:0.8];
}


@end
