
//  Created by VaxSoft
//  Copyright © 2025 VaxSoft. All rights reserved.

#import "cVaxPhoneSIP.h"
#import "cRecentRowView.h"

@implementation cRecentRowView

- (void)awakeFromNib
{
    [super awakeFromNib];
}

- (void) setSelected:(BOOL)selected animated:(BOOL)animated
{
    [super setSelected:selected animated:animated];
}

- (void) SetRowData :(cRecentRowData*) pRowData;
{
    m_pRowData = pRowData;
    
    [self UpdateLabelRecentName];
    [self UpdateImageCallType];
    [self UpdateLabelPhoneNo];
    [self UpdateLabelDateTime];
    [self UpdateLabelDuration];
}

- (void) UpdateLabelRecentName;
{
    [mLabelRecentName setText :[m_pRowData GetName]];
}

- (void) UpdateImageCallType;
{
    long nHistoryType = [m_pRowData GetHistoryTypeId];
    
    if(nHistoryType == VAX_CALL_HISTORY_TYPE_INBOUND)
        [mImageViewRecentCallType setImage: [UIImage imageNamed: @"aCallTypeInbound"]];
    
    else if(nHistoryType == VAX_CALL_HISTORY_TYPE_OUTBOUND)
        [mImageViewRecentCallType setImage: [UIImage imageNamed: @"aCallTypeOutbound"]];
    
    else if(nHistoryType == VAX_CALL_HISTORY_TYPE_MISSED)
        [mImageViewRecentCallType setImage: [UIImage imageNamed: @"aCallTypeMissed"]];
    
    else if(nHistoryType == VAX_CALL_HISTORY_TYPE_REJECTED)
        [mImageViewRecentCallType setImage: [UIImage imageNamed: @"aCallTypeInbound"]];
}

- (void) UpdateLabelPhoneNo;
{
    [mLabelRecentPhoneNo setText :[m_pRowData GetPhoneNo]];
}

- (void) UpdateLabelDateTime;
{
    UInt64 nDateTime = [m_pRowData GetDateTime];
    
    NSDate* pDate = [NSDate dateWithTimeIntervalSince1970: nDateTime];
    
    NSDateFormatter *dateFormat = [NSDateFormatter new];
    
    [dateFormat setDoesRelativeDateFormatting: YES];
    [dateFormat setDateStyle: NSDateFormatterShortStyle];
    
    NSString* pDateString = [dateFormat stringFromDate: pDate];
    
    if(([pDateString compare: @"Today" options:NSCaseInsensitiveSearch] != 0) && ([pDateString compare: @"Yesterday" options:NSCaseInsensitiveSearch] != 0))
    {
        [dateFormat setDoesRelativeDateFormatting: NO];
        [dateFormat setDateFormat:@"dd-MMM-YYYY"];
    }
    
    NSString* sDate = [dateFormat stringFromDate: pDate];
    [mLabelRecentDate setText :sDate];
    
    [dateFormat setDateFormat:@"hh:mm a"];
    NSString* sTime = [dateFormat stringFromDate:pDate];
    [mLabelRecentTime setText :sTime];
}

- (void) UpdateLabelDuration;
{
    UInt64 nDuration = [m_pRowData GetDuration];
    
    NSString* pHours; NSString* pMinutes; NSString* pSeconds;
    
    //nDuration = 7422;
    
    UInt64 nHours = nDuration/3600;
    
    if(nHours <= 9)
        pHours = [NSString stringWithFormat: @"0%llu", nHours];
    else
        pHours = [NSString stringWithFormat: @"%llu", nHours];
    
    ///////////////////
    
    UInt64 nMinutes = ((nDuration%3600)/60);
    
    if(nMinutes <= 9)
        pMinutes = [NSString stringWithFormat: @"0%llu", nMinutes];
    else
        pMinutes = [NSString stringWithFormat: @"%llu", nMinutes];
    
    ///////////////////
    
    UInt64 nSeconds = ((nDuration%3600)%60);
    
    if(nSeconds <= 9)
        pSeconds = [NSString stringWithFormat: @"0%llu", nSeconds];
    else
        pSeconds = [NSString stringWithFormat: @"%llu", nSeconds];
    
    ///////////////////
    
    NSString* sTime = [NSString stringWithFormat: @"%@:%@:%@", pHours, pMinutes, pSeconds];
    [mLabelRecentDuration setText :sTime];
    
}

@end
