
//  Created by VaxSoft
//  Copyright © 2025 VaxSoft. All rights reserved.

#import "cRecentSectionData.h"
#import "cRecentRowData.h"

@implementation cRecentSectionData

- (id) initWithDayNo :(long) nDayNo;
{    
    m_nDayNo = nDayNo;
    mpRowList = [NSMutableArray new];

    self = [super init];
    return self;
}

- (void) dealloc;
{
    [mpRowList removeAllObjects];
    mpRowList = nil;
}

//////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////

- (long) GetDayNo;
{
    return m_nDayNo;
}

- (NSString*) GetTitle;
{
    UInt64 nDateTime = m_nDayNo * 86400; //24 hours = 86400 seconds
    
    NSDate* pDate = [NSDate dateWithTimeIntervalSince1970: nDateTime];
    
    NSDateFormatter *dateFormat = [NSDateFormatter new];
    
    [dateFormat setDoesRelativeDateFormatting: YES];
    [dateFormat setDateStyle: NSDateFormatterShortStyle];
    
    NSString* pDateString = [dateFormat stringFromDate: pDate];
    
    if(([pDateString compare: @"Today" options:NSCaseInsensitiveSearch] != 0) && ([pDateString compare: @"Yesterday" options:NSCaseInsensitiveSearch] != 0))
    {
        [dateFormat setDoesRelativeDateFormatting: NO];
        [dateFormat setDateFormat:@"dd-MMM-YYYY"];
    }
    
    NSString* sDate = [dateFormat stringFromDate: pDate];
    return sDate;
}

//////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////

- (long) AddRow :(long) nRecordId :(bool) bOutboundCallType :(NSString*) sName :(NSString*) sPhoneNo :(long) nStartTime :(long) nEndTime :(long) nDuration :(long) nHistoryTypeId;
{
    cRecentRowData* pData = [cRecentRowData new];
    [pData SetCallInfo :nRecordId :bOutboundCallType :sName :sPhoneNo :nStartTime :nEndTime :nDuration :nHistoryTypeId];
    
    [mpRowList insertObject:pData atIndex:0];
    long nRowNo = 0;
    
    return nRowNo;
}

- (void) DeleteRow :(long) nRowNo;
{
    if(nRowNo >= [mpRowList count])
        return;
    
    [mpRowList removeObjectAtIndex :nRowNo];
}

- (cRecentRowData*) GetRowData :(long) nRowNo;
{
    if(nRowNo >= [mpRowList count])
        return nil;
    
    return (cRecentRowData*) [mpRowList objectAtIndex :nRowNo];
}

- (long) GetRowCount;
{
    return [mpRowList count];
}

@end
