
//  Created by VaxSoft
//  Copyright © 2025 VaxSoft. All rights reserved.

#import "cVaxPhoneSIP.h"

#import "cSettingDigitDTMFTableView.h"
#import "cSettingDigitDTMFRowView.h"

#import "cStoreDigitDTMF.h"

#define SECTION_TOTAL_COUNT             1
#define ROW_TOTAL_COUNT                 4

#define SECTION_ID_DTMF_TYPE            0

@interface cSettingDigitDTMFTableView ()
@end

@implementation cSettingDigitDTMFTableView

- (void) viewDidLoad
{
    [super viewDidLoad];
}

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
}

//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////

+ (void) ResetData;
{
    cStoreDigitDTMF* pStore = [cStoreDigitDTMF new];
    [pStore ResetData];
    
    [cSettingDigitDTMFTableView PostInitialize];
}

//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////

+ (void) PostInitialize;
{
    cStoreDigitDTMF* pStore = [cStoreDigitDTMF new];
    long nTypeDigitDTMF = [pStore GetDigitDTMF];
   
    [[cVaxPhoneDTMF GetSelf] ForceDigitDTMF :(int) nTypeDigitDTMF :true];
}

/////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////

- (void) viewWillAppear: (BOOL) animated
{
    cStoreDigitDTMF* pStore = [cStoreDigitDTMF new];
    m_nSelectedTypeDigitDTMF = [pStore GetDigitDTMF];
    
    [self.tableView reloadData];
    [super viewWillAppear :animated];
}

//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////

#pragma mark - Table view data source

- (NSInteger) numberOfSectionsInTableView :(UITableView *)tableView
{
    return SECTION_TOTAL_COUNT;
}

- (NSInteger) tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section
{
    return ROW_TOTAL_COUNT;
}

//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////

- (UITableViewCell *) tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath
 {
     Boolean bSelected = false;
     
     if(m_nSelectedTypeDigitDTMF == indexPath.row)
         bSelected = true;
     
     cSettingDigitDTMFRowView* pRowView = NULL;
     
     if(indexPath.row == VAX_DTMF_TYPE_AUTO && indexPath.section == SECTION_ID_DTMF_TYPE)
     {
         pRowView = [tableView dequeueReusableCellWithIdentifier:@"AutoCellId" forIndexPath:indexPath];
     }
     
     else if(indexPath.row == VAX_DTMF_TYPE_RFC2833 && indexPath.section == SECTION_ID_DTMF_TYPE)
     {
         pRowView = [tableView dequeueReusableCellWithIdentifier:@"RFC2833CellId" forIndexPath:indexPath];
     }
     
     else if(indexPath.row == VAX_DTMF_TYPE_SIP_INFO && indexPath.section == SECTION_ID_DTMF_TYPE)
     {
         pRowView = [tableView dequeueReusableCellWithIdentifier:@"SIPINFOCellId" forIndexPath:indexPath];
     }
     
     else if(indexPath.row == VAX_DTMF_TYPE_INBAND && indexPath.section == SECTION_ID_DTMF_TYPE)
     {
        pRowView = [tableView dequeueReusableCellWithIdentifier:@"InbandCellId" forIndexPath:indexPath];
     }
     
     [pRowView SetSelected :bSelected];
     return pRowView;
}

//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////

- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath
{
    long nTypeDigitDTMF = indexPath.row;
    m_nSelectedTypeDigitDTMF = nTypeDigitDTMF;
    
    for(int nRowNo = 0; nRowNo < ROW_TOTAL_COUNT; nRowNo++)
    {
        cSettingDigitDTMFRowView* pRowView = (cSettingDigitDTMFRowView*) [self.tableView cellForRowAtIndexPath: [NSIndexPath indexPathForRow: nRowNo inSection: SECTION_ID_DTMF_TYPE]];
        if(pRowView != nil) [pRowView SetSelected :NO];
    }
    
    cSettingDigitDTMFRowView* pRowView = (cSettingDigitDTMFRowView*) [self.tableView cellForRowAtIndexPath: indexPath];
    if(pRowView != nil) [pRowView SetSelected :YES];
    
    [[cVaxPhoneDTMF GetSelf] ForceDigitDTMF :(int) nTypeDigitDTMF :true];
    
    cStoreDigitDTMF* pStore = [cStoreDigitDTMF new];
    [pStore SetDigitDTMF :nTypeDigitDTMF];
}

//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////

@end
