
//  Created by VaxSoft
//  Copyright © 2025 VaxSoft. All rights reserved.

#import "cVaxPhoneSIP.h"

#import "cSettingNetworkTableView.h"
#import "cSettingNetworkRowView.h"

#import "cStoreNetwork.h"

#define SECTION_TOTAL_COUNT         1
#define SECTION_ROW_COUNT_SIP       2

#define ROW_ID_LOCAL_PORT_SIP       0
#define ROW_ID_CHOOSE_RANDOM_SIP    1

//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////

@interface cSettingNetworkTableView ()
@end

@implementation cSettingNetworkTableView

- (void)viewDidLoad
{
    [super viewDidLoad];
}

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
}

//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////

+ (void) ResetData;
{
    cStoreNetwork* pStore = [cStoreNetwork new];
    [pStore ResetData];
}

//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////

+ (int) GetNetworkPortSIP;
{
    cStoreNetwork* pStore = [cStoreNetwork new];
    return (int) [pStore GetLocalPortSIP];
}

+ (Boolean) IsRandomPortSIP;
{
    cStoreNetwork* pStore = [cStoreNetwork new];
    return [pStore GetChooseRandomlySIP];
}

/////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////

- (void) viewWillAppear: (BOOL) animated
{
    cStoreNetwork* pStore = [cStoreNetwork new];
    
    mnLocalPortSIP = [pStore GetLocalPortSIP];
    mbRandomlyPortSIP = [pStore GetChooseRandomlySIP];
    
    [self.tableView reloadData];
    [super viewWillAppear :animated];
}

//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////

#pragma mark - Table view data source

- (NSInteger) numberOfSectionsInTableView:(UITableView *)tableView
{
    return SECTION_TOTAL_COUNT;
}

- (NSInteger) tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section
{
    return SECTION_ROW_COUNT_SIP;
}

//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////

- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath
{
    if(indexPath.row == ROW_ID_LOCAL_PORT_SIP)
    {
        cSettingNetworkRowView* pRowView = [tableView dequeueReusableCellWithIdentifier:@"LocalPortSIPCellId" forIndexPath:indexPath];
    
        [pRowView UpdateTextField :[[NSNumber numberWithLong :mnLocalPortSIP] stringValue]];
        return pRowView;
    }
    
    cSettingNetworkRowView* pRowView = [tableView dequeueReusableCellWithIdentifier:@"ChooseRandomlySIPCellId" forIndexPath:indexPath];
    
    [pRowView UpdateCheckBox :mbRandomlyPortSIP];
    return pRowView;
}

//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////

- (IBAction) OnEditingTextFieldPortSIP :(id) sender;
{
    NSString* sLocalPortSIP = [((cCustomTextField*) sender) text];
    
    if(sLocalPortSIP == nil || [sLocalPortSIP length] == 0)
        return;
    
    cStoreNetwork* pStore = [cStoreNetwork new];
    [pStore SetLocalPortSIP :[sLocalPortSIP integerValue]];
}

-(IBAction) OnClickCheckBoxRandomSIP :(id)sender
{
    cCustomCellCheckBox* pCheckBox = (cCustomCellCheckBox*) sender;
    
    cStoreNetwork* pStore = [cStoreNetwork new];
    [pStore SetChooseRandomlySIP :[pCheckBox GetState]];
}

//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////

@end
