
//  Created by VaxSoft
//  Copyright © 2025 VaxSoft. All rights reserved.

#import "cVaxPhoneSIP.h"

#import "cSettingRingToneTableView.h"
#import "cSettingRingToneRowView.h"

#import "cStoreRingtones.h"

#define SECTION_TOTAL_COUNT         1
#define SECTION_ID_RINGTONE         0
#define ROW_TOTAL_COUNT             5

@interface cSettingRingToneTableView ()
@end

@implementation cSettingRingToneTableView

- (void) viewDidLoad
{
    [super viewDidLoad];
}

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
}

//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////

+ (void) ResetData;
{
    cStoreRingtones* pStore = [cStoreRingtones new];
    [pStore ResetData];
    
    [cSettingRingToneTableView PostInitialize];
}

//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////

+ (void) PostInitialize;
{
    cStoreRingtones* pStore = [cStoreRingtones new];
    
    long nToneId = [pStore GetRingtone];
    [[cVaxPhoneRing GetSelf] SetRingTone :(int) nToneId];
}

//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////

- (void) viewWillAppear: (BOOL) animated
{
    cStoreRingtones* pStore = [cStoreRingtones new];
    m_nSelectedRingToneId = [pStore GetRingtone];
    
    [self.tableView reloadData];
    [super viewWillAppear :animated];
}

//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////

#pragma mark - Table view data source

- (NSInteger)numberOfSectionsInTableView :(UITableView *)tableView
{
    return SECTION_TOTAL_COUNT;
}

- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section
{
    return ROW_TOTAL_COUNT;
}

- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath
 {
     Boolean bSelected = false;
     
     if(m_nSelectedRingToneId == indexPath.row)
         bSelected = true;
     
     cSettingRingToneRowView* pRowView = nil;
     
     if(indexPath.row == VAX_RING_TONE_GROOVY && indexPath.section == 0)
     {
         pRowView = [tableView dequeueReusableCellWithIdentifier:@"GroovyCellId" forIndexPath:indexPath];
     }
     
     else if(indexPath.row == VAX_RING_TONE_DIGITAL_RAIN && indexPath.section == 0)
     {
         pRowView = [tableView dequeueReusableCellWithIdentifier:@"DigitalRainCellId" forIndexPath:indexPath];
     }
     
     else if(indexPath.row == VAX_RING_TONE_MAGICAL && indexPath.section == 0)
     {
        pRowView = [tableView dequeueReusableCellWithIdentifier:@"MagicalCellId" forIndexPath:indexPath];
     }
     
     else if(indexPath.row == VAX_RING_TONE_DEJA_VU && indexPath.section == 0)
     {
        pRowView = [tableView dequeueReusableCellWithIdentifier:@"DejaVuCellId" forIndexPath:indexPath];
     }
     else
     {
         pRowView = [tableView dequeueReusableCellWithIdentifier:@"OfficePhoneCellId" forIndexPath:indexPath];
     }
     
     [pRowView SetSelected :bSelected];
     return pRowView;
}

//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////

- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath
{
    long nRingToneId = indexPath.row;
    m_nSelectedRingToneId = nRingToneId;
    
    for(int nRowNo = 0; nRowNo < ROW_TOTAL_COUNT; nRowNo++)
    {
        cSettingRingToneRowView* pRowView = (cSettingRingToneRowView*) [self.tableView cellForRowAtIndexPath: [NSIndexPath indexPathForRow: nRowNo inSection: SECTION_ID_RINGTONE]];
        if(pRowView != nil) [pRowView SetSelected :NO];
    }
    
    cSettingRingToneRowView* pRowView = (cSettingRingToneRowView*) [self.tableView cellForRowAtIndexPath: indexPath];
    if(pRowView != nil) [pRowView SetSelected :YES];
    
    [[cVaxPhoneRing GetSelf] SetRingTone :(int) nRingToneId];
    
    cStoreRingtones* pStore = [cStoreRingtones new];
    [pStore SetRingtone :nRingToneId];
}

//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////

@end
