
//  Created by VaxSoft
//  Copyright © 2025 VaxSoft. All rights reserved.

#import "cVaxPhoneSIP.h"

#import "cSettingVideoBitrateTableView.h"
#import "cSettingVideoBitrateRowView.h"

#import "cStoreVideoBitrate.h"

#define SECTION_TOTAL_COUNT                   1
#define ROW_TOTAL_COUNT                       5

#define SECTION_ID_BITRATE_QUALITY            0

@interface cSettingVideoBitrateTableView ()
@end

@implementation cSettingVideoBitrateTableView

- (void) viewDidLoad
{
    [super viewDidLoad];
}

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
}

//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////

+ (void) PostInitialize;
{
    cStoreVideoBitrate* pStore = [cStoreVideoBitrate new];
    long nBitrateTypeId = [pStore GetVideoBitrate];
    
    [[cVaxPhoneVideo GetSelf] ApplyVideoBitrate :(int) nBitrateTypeId];
}

+ (void) ResetData;
{
    cStoreVideoBitrate* pStore = [cStoreVideoBitrate new];
    [pStore ResetData];
    
    [cSettingVideoBitrateTableView PostInitialize];
}

/////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////

- (void) viewWillAppear: (BOOL) animated
{
    maBitrateName = [NSArray arrayWithObjects: @"Low", @"Normal", @"Medium", @"High", @"Maximum", nil];
    
    cStoreVideoBitrate* pStore = [cStoreVideoBitrate new];
    mnSelectedBitrateTypeId = [pStore GetVideoBitrate];

    [self.tableView reloadData];
    [super viewWillAppear :animated];
}

//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////

#pragma mark - Table view data source

- (NSInteger) numberOfSectionsInTableView :(UITableView *)tableView
{
    return SECTION_TOTAL_COUNT;
}

- (NSInteger) tableView :(UITableView *)tableView numberOfRowsInSection:(NSInteger)section
{
    return ROW_TOTAL_COUNT;
}

//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////

- (UITableViewCell *) tableView :(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath
{
    Boolean bSelected = false;
    
    if(mnSelectedBitrateTypeId == indexPath.row)
    {
        bSelected = true;
    }
    
    cSettingVideoBitrateRowView* pRowView = [tableView dequeueReusableCellWithIdentifier:@"VideoBitrateCellId" forIndexPath:indexPath];
    
    [pRowView SetNameType :[maBitrateName objectAtIndex :indexPath.row]];
    [pRowView SetSelected :bSelected];
    
    return pRowView;
}

//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////

- (void) tableView :(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath
{
    long nBitrateTypeId = indexPath.row;
    mnSelectedBitrateTypeId = nBitrateTypeId;
    
    for(int nRowNo = 0; nRowNo < ROW_TOTAL_COUNT; nRowNo++)
    {
        cSettingVideoBitrateRowView* pRowView = (cSettingVideoBitrateRowView*) [self.tableView cellForRowAtIndexPath: [NSIndexPath indexPathForRow: nRowNo inSection: SECTION_ID_BITRATE_QUALITY]];
        if(pRowView != nil) [pRowView SetSelected :NO];
    }
    
    cSettingVideoBitrateRowView* pRowView = (cSettingVideoBitrateRowView*) [self.tableView cellForRowAtIndexPath: indexPath];
    if(pRowView != nil) [pRowView SetSelected :YES];
    
    cStoreVideoBitrate* pStore = [cStoreVideoBitrate new];
    [pStore SetVideoBitrate : (int) nBitrateTypeId];
    
    [[cVaxPhoneVideo GetSelf] ApplyVideoBitrate :(int) nBitrateTypeId];
}


@end
