
//  Created by VaxSoft
//  Copyright © 2025 VaxSoft. All rights reserved.

#import "cVaxPhoneSIP.h"

#import "cSettingVideoQualityTableView.h"
#import "cSettingVideoQualityRowView.h"

#import "cStoreVideoQuality.h"

#define SECTION_TOTAL_COUNT                   1
#define ROW_TOTAL_COUNT                       5
#define SECTION_ID_VIDEO_QUALITY              0

@interface cSettingVideoQualityTableView ()
@end

@implementation cSettingVideoQualityTableView

- (void) viewDidLoad
{
    [super viewDidLoad];
}

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
}

//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////

+ (void) ResetData;
{
    cStoreVideoQuality* pStore = [cStoreVideoQuality new];
    [pStore ResetData];
}

/////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////

- (void) viewWillAppear: (BOOL) animated
{
    maQualityName = [NSArray arrayWithObjects: @"Low", @"Normal", @"Medium", @"High", @"Maximum", nil];
    
    cStoreVideoQuality* pStore = [cStoreVideoQuality new];
    mnSelectedQualityTypeId = [pStore GetVideoQuality];
    
    [self.tableView reloadData];
    [super viewWillAppear :animated];
}

//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////

+ (int) GetVideoQuality;
{
    cStoreVideoQuality* pStore = [cStoreVideoQuality new];
    return (int) [pStore GetVideoQuality];
}

//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////

#pragma mark - Table view data source

- (NSInteger) numberOfSectionsInTableView :(UITableView *)tableView
{
    return SECTION_TOTAL_COUNT;
}

- (NSInteger) tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section
{
    return ROW_TOTAL_COUNT;
}

//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////

- (UITableViewCell *) tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath
{
    Boolean bSelected = false;
    
    if(mnSelectedQualityTypeId == indexPath.row)
    {
        bSelected = true;
    }
    
    cSettingVideoQualityRowView* pRowView = [tableView dequeueReusableCellWithIdentifier:@"VideoQualityCellId" forIndexPath:indexPath];
    
    [pRowView SetNameType :[maQualityName objectAtIndex :indexPath.row]];
    [pRowView SetSelected :bSelected];
    
    return pRowView;
}

//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////

- (void) tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath
{
    long nQualityTypeId = indexPath.row;
    mnSelectedQualityTypeId = nQualityTypeId;
    
    for(int nRowNo = 0; nRowNo < ROW_TOTAL_COUNT; nRowNo++)
    {
        cSettingVideoQualityRowView* pRowView = (cSettingVideoQualityRowView*) [self.tableView cellForRowAtIndexPath: [NSIndexPath indexPathForRow: nRowNo inSection: SECTION_ID_VIDEO_QUALITY]];
        if(pRowView != nil) [pRowView SetSelected :NO];
    }
    
    cSettingVideoQualityRowView* pRowView = (cSettingVideoQualityRowView*) [self.tableView cellForRowAtIndexPath: indexPath];
    if(pRowView != nil) [pRowView SetSelected :YES];
    
    cStoreVideoQuality* pStore = [cStoreVideoQuality new];
    [pStore SetVideoQuality :(int) nQualityTypeId];
    
    [[cVaxPhoneVideo GetSelf] ApplyVideoQuality];
}

@end
