
//  Created by VaxSoft
//  Copyright © 2025 VaxSoft. All rights reserved.

#import "cVaxPhoneSIP.h"

#import "cSettingVoiceChangerTableView.h"
#import "cSettingVoiceChangerRowView.h"

#import "cStoreVoiceChanger.h"

#define SECTION_TOTAL_COUNT               1
#define ROW_TOTAL_COUNT                   5

#define SECTION_ID_VOICE_CHANGER          0

@interface cSettingVoiceChangerTableView ()
@end

@implementation cSettingVoiceChangerTableView

- (void) viewDidLoad
{
    [super viewDidLoad];
}

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
}

//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////

+ (void) ResetData;
{
    cStoreVoiceChanger* pStore = [cStoreVoiceChanger new];
    [pStore ResetData];
}

//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////

+ (int) GetSelectedPitchNo;
{
    cStoreVoiceChanger* pStore = [cStoreVoiceChanger new];
    long nVoiceChangerId = [pStore GetVoiceChanger];
    
    long aVoicePitch[] = {VAX_VOICE_PITCH_GRANDPA_DRUNK, VAX_VOICE_PITCH_TEEN_BOY, VAX_VOICE_PITCH_HOUSE_HOLD_REBOT, VAX_VOICE_PITCH_HELIUM_INHALED, VAX_VOICE_PITCH_CHIPMUNK};
    return (int) aVoicePitch[nVoiceChangerId];
}

//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////

- (void) viewWillAppear: (BOOL) animated
{
    cStoreVoiceChanger* pStore = [cStoreVoiceChanger new];
    m_nSelectedVoiceChangerId = [pStore GetVoiceChanger];
    
    [self.tableView reloadData];
    [super viewWillAppear :animated];
}

//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////

#pragma mark - Table view data source

- (NSInteger) numberOfSectionsInTableView :(UITableView *)tableView
{
    return SECTION_TOTAL_COUNT;
}

- (NSInteger) tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section
{
    return ROW_TOTAL_COUNT;
}

//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////

- (UITableViewCell *) tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath
 {
     Boolean bSelected = false;
     
     if(m_nSelectedVoiceChangerId == indexPath.row)
     {
         bSelected = true;
     }
     
     cSettingVoiceChangerRowView* pRowView = nil;
     
     if(indexPath.row == VAX_VOICE_CHANGER_GRANDPA_DRUNK && indexPath.section == SECTION_ID_VOICE_CHANGER)
     {
         pRowView = [tableView dequeueReusableCellWithIdentifier:@"GrandpadrunkCellId" forIndexPath:indexPath];
     }
     
     else if(indexPath.row == VAX_VOICE_CHANGER_TEEN_BOY && indexPath.section == SECTION_ID_VOICE_CHANGER)
     {
         pRowView = [tableView dequeueReusableCellWithIdentifier:@"TeenboyCellId" forIndexPath:indexPath];
     }
     
     else if(indexPath.row == VAX_VOICE_CHANGER_HOUSE_HOLD_REBOT && indexPath.section == SECTION_ID_VOICE_CHANGER)
     {
         pRowView = [tableView dequeueReusableCellWithIdentifier:@"HouseholdrobotCellId" forIndexPath:indexPath];
     }
     
     else if(indexPath.row == VAX_VOICE_CHANGER_HELIUM_INHALED && indexPath.section == SECTION_ID_VOICE_CHANGER)
     {
         pRowView = [tableView dequeueReusableCellWithIdentifier:@"HeliuminhaledCellId" forIndexPath:indexPath];
     }
     else
     {
         pRowView = [tableView dequeueReusableCellWithIdentifier:@"ChipmunkCellId" forIndexPath:indexPath];
     }
     
     [pRowView SetSelected :bSelected];
     return pRowView;
}

//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////

- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath
{
    long nVoiceChangerId = indexPath.row;
    m_nSelectedVoiceChangerId = nVoiceChangerId;
    
    for(int nRowNo = 0; nRowNo < ROW_TOTAL_COUNT; nRowNo++)
    {
        cSettingVoiceChangerRowView* pRowView = [self.tableView cellForRowAtIndexPath: [NSIndexPath indexPathForRow: nRowNo inSection: SECTION_ID_VOICE_CHANGER]];
        if(pRowView != nil) [pRowView SetSelected :NO];
    }
    
    cSettingVoiceChangerRowView* pRowView = [self.tableView cellForRowAtIndexPath: indexPath];
    if(pRowView != nil) [pRowView SetSelected :YES];
    
    cStoreVoiceChanger* pStore = [cStoreVoiceChanger new];
    [pStore SetVoiceChanger: nVoiceChangerId];
    
    if([[cVaxPhoneVoiceChanger GetSelf] IsVoiceChangerEnabled])
        [[cVaxPhoneVoiceChanger GetSelf] VoiceChanger :true];
}

//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////

@end
