
//  Created by VaxSoft
//  Copyright © 2025 VaxSoft. All rights reserved.

#import "cDialPadView.h"
#import "cCustomTextField.h"

#import "cVaxPhoneSIP.h"

#import "cAddressBookView.h"
#import "cMainTabBarController.h"
#import "cVideoView.h"

@interface cDialPadView ()
@end

static cDialPadView* mpDialPadView = NULL;
static NSMutableString* mpDialPadStatusText = NULL;
static NSMutableString* mpDialPadPhoneNoText = NULL;

@implementation cDialPadView

- (void) viewDidLoad
{
    [super viewDidLoad];
    
    [mTextFieldDialNo EnableKeyboardReturnKey];
    mpContactsView = [cAddressBookView new];
}

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
}

/////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////

- (void) viewWillAppear: (BOOL) animated
{
    mpDialPadView = self;
    
    [mTextFieldDialNo setText :mpDialPadPhoneNoText];
    
    [self ShowStatusMsg :mpDialPadStatusText];
    [self UpdateButton];
    
    [super viewWillAppear :animated];
}

- (void) viewDidAppear: (BOOL) animated
{
    
    [super viewDidAppear :animated];
}

- (void) viewWillDisappear: (BOOL)animated;
{
    mpDialPadView = NULL;
    [super viewWillDisappear :animated];
}

//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////

+ (void) OnStartedAPP;
{
    mpDialPadStatusText = [NSMutableString new];
    mpDialPadPhoneNoText = [NSMutableString new];
}

+ (void) PostDialCallStarted;
{
    if(mpDialPadView != NULL)
        [mpDialPadView UpdateButton];
}

+ (void) PostDialCallFailed :(int) nStatusCode :(NSString*) sReasonPhrase;
{
    if(mpDialPadView != NULL)
        [mpDialPadView UpdateButton];
}

+ (void) PostConnectedCall;
{    
    if(mpDialPadView != NULL)
        [mpDialPadView UpdateButton];
}

+ (void) PostDisconnectedCall;
{
    if(mpDialPadView != NULL)
        [mpDialPadView UpdateButton];
}

+ (void) PostPhoneNoText :(NSString*) sNoText;
{
    [mpDialPadPhoneNoText setString :sNoText];
}

//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////

- (IBAction) OnClickDigit1 :(id)sender;
{
    [mTextFieldDialNo setText :[mTextFieldDialNo.text stringByAppendingString :@"1"]];
    [[cVaxPhoneDTMF GetSelf] PlayDTMF :@"1"];
    
    [mpDialPadPhoneNoText setString: mTextFieldDialNo.text];
}

- (IBAction) OnClickDigit2 :(id)sender;
{
    [mTextFieldDialNo setText :[mTextFieldDialNo.text stringByAppendingString :@"2"]];
    [[cVaxPhoneDTMF GetSelf] PlayDTMF :@"2"];
    
    [mpDialPadPhoneNoText setString: mTextFieldDialNo.text];
}

- (IBAction) OnClickDigit3 :(id)sender;
{
    [mTextFieldDialNo setText :[mTextFieldDialNo.text stringByAppendingString :@"3"]];
    [[cVaxPhoneDTMF GetSelf] PlayDTMF :@"3"];
    
    [mpDialPadPhoneNoText setString: mTextFieldDialNo.text];
}

- (IBAction) OnClickDigit4 :(id)sender;
{
    [mTextFieldDialNo setText :[mTextFieldDialNo.text stringByAppendingString :@"4"]];
    [[cVaxPhoneDTMF GetSelf] PlayDTMF :@"4"];
    
    [mpDialPadPhoneNoText setString: mTextFieldDialNo.text];
}

- (IBAction) OnClickDigit5 :(id)sender;
{
    [mTextFieldDialNo setText :[mTextFieldDialNo.text stringByAppendingString :@"5"]];
    [[cVaxPhoneDTMF GetSelf] PlayDTMF :@"5"];
    
    [mpDialPadPhoneNoText setString: mTextFieldDialNo.text];
}

- (IBAction) OnClickDigit6 :(id)sender;
{
    [mTextFieldDialNo setText :[mTextFieldDialNo.text stringByAppendingString :@"6"]];
    [[cVaxPhoneDTMF GetSelf] PlayDTMF :@"6"];
    
    [mpDialPadPhoneNoText setString: mTextFieldDialNo.text];
}

- (IBAction) OnClickDigit7 :(id)sender;
{
    [mTextFieldDialNo setText :[mTextFieldDialNo.text stringByAppendingString :@"7"]];
    [[cVaxPhoneDTMF GetSelf] PlayDTMF :@"7"];
    
    [mpDialPadPhoneNoText setString: mTextFieldDialNo.text];
}

- (IBAction) OnClickDigit8 :(id)sender;
{
    [mTextFieldDialNo setText :[mTextFieldDialNo.text stringByAppendingString: @"8"]];
    [[cVaxPhoneDTMF GetSelf] PlayDTMF :@"8"];
    
    [mpDialPadPhoneNoText setString: mTextFieldDialNo.text];
}

- (IBAction) OnClickDigit9 :(id)sender;
{
    [mTextFieldDialNo setText :[mTextFieldDialNo.text stringByAppendingString: @"9"]];
    [[cVaxPhoneDTMF GetSelf] PlayDTMF :@"9"];
    
    [mpDialPadPhoneNoText setString: mTextFieldDialNo.text];
}

- (IBAction) OnClickDigit0 :(id)sender;
{
    [mTextFieldDialNo setText :[mTextFieldDialNo.text stringByAppendingString: @"0"]];
    [[cVaxPhoneDTMF GetSelf] PlayDTMF :@"0"];
    
    [mpDialPadPhoneNoText setString: mTextFieldDialNo.text];
}

- (IBAction) OnClickHash:(id)sender;
{
    [mTextFieldDialNo setText :[mTextFieldDialNo.text stringByAppendingString: @"#"]];
    [[cVaxPhoneDTMF GetSelf] PlayDTMF :@"#"];
    
    [mpDialPadPhoneNoText setString: mTextFieldDialNo.text];
}

- (IBAction) OnClickStar :(id)sender;
{
    [mTextFieldDialNo setText :[mTextFieldDialNo.text stringByAppendingString: @"*"]];
    [[cVaxPhoneDTMF GetSelf] PlayDTMF :@"*"];
    
    [mpDialPadPhoneNoText setString: mTextFieldDialNo.text];
}

- (IBAction) OnClickCall :(id)sender;
{
    if(mTextFieldDialNo.text.length == 0)
        return;
    
    if(![[cVaxPhoneSIP GetSelf] DialCall :mTextFieldDialNo.text])
      return;
    
    [self UpdateButton];
    [self performSegueWithIdentifier: @"SegueUnwindDialPadView" sender: self];
}

- (IBAction) OnClickEnd:(id)sender
{
    if(![[cVaxPhoneSIP GetSelf] DisconnectCall])
        return;
    
    [self UpdateButton];
}

- (IBAction) OnClickContact :(id)sender;
{
    [self ShowAddressBookUI];
}

//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////

- (IBAction) OnClickRemoveUp:(id)sender;
{
    [mTextFieldDialNo ClearTextStop];
    [mpDialPadPhoneNoText setString: mTextFieldDialNo.text];
}

- (IBAction) OnClickRemoveDown:(id)sender;
{
    [mTextFieldDialNo ClearTextStart];
    [mpDialPadPhoneNoText setString: mTextFieldDialNo.text];
}

//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////

- (IBAction) OnClickHold:(id)sender
{
    if(![[cVaxPhoneGeneral GetSelf] HoldLine])
        return;
    
    [self UpdateButton];
}

- (IBAction)OnClickUnhold:(id)sender
{
    if(![[cVaxPhoneGeneral GetSelf] UnHoldLine])
        return;
    
    [self UpdateButton];
}

//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////

- (void) UpdateButton;
{
    if([[cVaxPhoneGeneral GetSelf] IsLineHold])
    {
        [mDialCall setHidden :true];
        [mEndCall setHidden :false];
        
        [mHoldCall setHidden :true];
        [mUnHoldCall setHidden :false];
        
        [mContact setHidden :true];
    }
    else if([[cVaxPhoneGeneral GetSelf] IsLineConnected])
    {
        [mDialCall setHidden :true];
        [mEndCall setHidden :false];
        
        [mHoldCall setHidden :false];
        [mUnHoldCall setHidden :true];
        
        [mContact setHidden :true];
    }
    else if([[cVaxPhoneGeneral GetSelf] IsLineBusy])
    {
        [mDialCall setHidden :true];
        [mEndCall setHidden :false];
        
        [mHoldCall setHidden :false];
        [mUnHoldCall setHidden :true];
        
        [mContact setHidden :true];
    }
    else
    {
        [mDialCall setHidden :false];
        [mEndCall setHidden :true];
        
        [mHoldCall setHidden :true];
        [mUnHoldCall setHidden :true];
        
        [mContact setHidden :false];
    }
}

+ (void) PostStatusText :(NSString*) sMsgText;
{
    [mpDialPadStatusText setString :sMsgText];
    
    if(mpDialPadView != NULL)
        [mpDialPadView ShowStatusMsg :sMsgText];
}

- (void) ShowStatusMsg :(NSString*) sMsgText;
{

}

- (Boolean) ShowAddressBookUI;
{
    mpContactsView = [[cAddressBookView alloc] initWith :self];
    [mpContactsView ShowContacts :self :false];
    
    return true;
}

- (void) OnAddressBookSelectedPhoneNo :(NSString*) sPhoneNo;
{
    [mTextFieldDialNo setText :sPhoneNo];
    [mpDialPadPhoneNoText setString: mTextFieldDialNo.text];
}

//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////

@end
