
//  Created by VaxSoft
//  Copyright © 2025 VaxSoft. All rights reserved.

#import "cVideoDeviceView.h"

@interface cVideoDeviceView ()
@end

static cVideoDeviceView* mpVideoDeviceView = NULL;

@implementation cVideoDeviceView

- (void)viewDidLoad
{
    //mDisplayLayer = [CALayer layer];
    mDisplayLayer = self.view.layer;
    
    m_nLastWidth  = -1;
    m_nLastHeight = -1;
    
    [super viewDidLoad];
}

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
}

- (void) viewWillAppear:(BOOL)animated
{
    mpVideoDeviceView = self;
    [super viewWillAppear :animated];
}

- (void) viewDidAppear:(BOOL)animated
{
    [super viewDidAppear :animated];
    
    [self AdjustSize :false];
    //[self.view.layer addSublayer :mDisplayLayer];
}

- (void) viewWillDisappear:(BOOL)animated
{
    mpVideoDeviceView = NULL;
    [super viewWillDisappear :animated];
}

+ (void) ShowView;
{
    if(mpVideoDeviceView == NULL)
        return;
    
    if([mpVideoDeviceView.view isHidden])
    {
        [mpVideoDeviceView.view setHidden :false];
    }
}

- (void) touchesBegan :(NSSet *)touches withEvent:(UIEvent *)event
{
    if(![self.view isHidden])
    {
        [mpVideoDeviceView.view setHidden :true];
    }
}


//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////

- (void) OnAdjustSize;
{
    //mDisplayLayer.bounds = CGRectMake(0, 0, self.view.frame.size.width, self.view.frame.size.height);
    //mDisplayLayer.position = CGPointMake(self.view.frame.size.width/2.0, self.view.frame.size.height/2.0);
}

- (void) AdjustSize :(Boolean) bAfterDelay;
{
    [NSObject cancelPreviousPerformRequestsWithTarget:self selector:@selector(OnAdjustSize) object:nil];
    
    if(bAfterDelay)
        [self performSelector :@selector(OnAdjustSize) withObject:nil afterDelay:0.5];
    else
        [self OnAdjustSize];
}

//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////

- (void) viewWillTransitionToSize:(CGSize)size withTransitionCoordinator:(id<UIViewControllerTransitionCoordinator>)coordinator ;
{
    [self AdjustSize :true];
}

- (void) DisplayFrame :(char*)pDataRGB :(int)nWidth :(int)nHeight;
{
    if(m_nLastWidth != nWidth || m_nLastHeight != nHeight)
    {
        [self AdjustSize :true];
        
        m_nLastWidth = nWidth;
        m_nLastHeight = nHeight;
    }
    
    CGColorSpaceRef colorSpace = CGColorSpaceCreateDeviceRGB();
    CGContextRef context = CGBitmapContextCreate (pDataRGB, nWidth, nHeight, 8, nWidth * 4, colorSpace, kCGBitmapByteOrder32Little | kCGImageAlphaPremultipliedFirst);
    
    CGImageRef quartzImage = CGBitmapContextCreateImage (context);
    
    mDisplayLayer.contents = (__bridge id)quartzImage;
    
    CGImageRelease (quartzImage);
    CGContextRelease (context);
    CGColorSpaceRelease (colorSpace);
}

+ (void) PostFrameRGB :(char*) pFrameRGB :(int) nFrameSize :(int) nFrameWidth :(int) nFrameHeight;
{
    if(mpVideoDeviceView == NULL)
        return;
    
    [mpVideoDeviceView DisplayFrame :pFrameRGB :nFrameWidth :nFrameHeight];
}

@end
