
//  Created by VaxSoft
//  Copyright © 2025 VaxSoft. All rights reserved.

#import "cDataPRF.h"

@implementation cDataPRF

- (id) init;
{
    self = [super init];
    return self;
}

- (void) dealloc;
{
    
}

- (void) WriteString :(NSString*) sKey :(NSString*) sData;
{
    NSUserDefaults* pRefs = [NSUserDefaults standardUserDefaults];
    
    [pRefs setObject :sData forKey:sKey];
    [pRefs synchronize];
}

- (void) WriteBoolean :(NSString*) sKey :(Boolean) bData;
{
    NSUserDefaults* pRefs = [NSUserDefaults standardUserDefaults];
    
    [pRefs setObject :[NSNumber numberWithBool: bData] forKey:sKey];
    [pRefs synchronize];
}

- (void) WriteInteger :(NSString*) sKey :(long) nData;
{
    NSUserDefaults* pRefs = [NSUserDefaults standardUserDefaults];
    
    [pRefs setObject :[NSNumber numberWithLong: nData] forKey:sKey];
    [pRefs synchronize];
}

- (void) WriteArray :(NSString*) sKey :(NSArray*) aData;
{
    NSUserDefaults* pRefs = [NSUserDefaults standardUserDefaults];
    
    [pRefs setObject :aData forKey:sKey];
    [pRefs synchronize];
}

//////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////

- (NSString*) ReadString :(NSString*) sKey :(NSString*) sDefaultData;
{
    NSUserDefaults* pRefs = [NSUserDefaults standardUserDefaults];
    
    NSString* sData = [pRefs objectForKey :sKey];
    if (sData == nil) return sDefaultData;
    
    return sData;
}

- (Boolean) ReadBoolean :(NSString*) sKey :(Boolean) bDefaultData;
{
    NSUserDefaults* pRefs = [NSUserDefaults standardUserDefaults];
    
    NSNumber* pValue = [pRefs objectForKey :sKey];
    if(pValue == nil) return bDefaultData;
    
    return [pValue boolValue];
}

- (long) ReadInt :(NSString*) sKey :(long) nDefaultData;
{
    NSUserDefaults* pRefs = [NSUserDefaults standardUserDefaults];
    
    NSNumber* pValue = [pRefs objectForKey :sKey];
    if(pValue == nil) return nDefaultData;
    
    return [pValue longValue];
}

- (NSArray*) ReadArray :(NSString*) sKey :(NSArray*) aDefaultData;
{
    NSUserDefaults* pRefs = [NSUserDefaults standardUserDefaults];
    
    NSArray* aData = [pRefs objectForKey :sKey];
    if(aData == nil) return aDefaultData;

    return aData;
}

//////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////

- (void) RemoveKey :(NSString*) sKey;
{
    NSUserDefaults* pRefs = [NSUserDefaults standardUserDefaults];
    
    [pRefs removeObjectForKey:sKey];
    [pRefs synchronize];
}

@end
