
//  Created by VaxSoft
//  Copyright © 2025 VaxSoft. All rights reserved.

#import "cStoreAccount.h"

#define ACCOUNT_USER_NAME               @"AccountUserName"
#define ACCOUNT_DISPLAY_NAME            @"AccountDisplayName"

#define ACCOUNT_AUTH_LOGIN              @"AccountAuthLogin"
#define ACCOUNT_AUTH_PWD                @"AccountAuthPwd"

#define ACCOUNT_DOMAIN_REALM            @"AccountDomainRealm"

#define ACCOUNT_SERVER_ADDR             @"AccountServerAddr"
#define ACCOUNT_SERVER_PORT             @"AccountServerPort"

#define ACCOUNT_REGISTRATION            @"AccountRegistration"
#define ACCOUNT_STATUS_ONLINE           @"AccountStatusOnline"


#define ACCOUNT_USER_NAME_DEFAULT       @""
#define ACCOUNT_DISPLAY_NAME_DEFAULT    @""

#define ACCOUNT_AUTH_LOGIN_DEFAULT      @""
#define ACCOUNT_AUTH_PWD_DEFAULT        @""

#define ACCOUNT_DOMAIN_REALM_DEFAULT    @""

#define ACCOUNT_SERVER_ADDR_DEFAULT     @""
#define ACCOUNT_SERVER_PORT_DEFAULT     @"5060"

#define ACCOUNT_REGISTRATION_DEFAULT    true
#define ACCOUNT_STATUS_ONLINE_DEFAULT   false


@implementation cStoreAccount

- (id) init;
{
    m_pDataPRF = [cDataPRF new];
    
    self = [super init];
    return self;
}

- (void) dealloc;
{
}

//////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////

- (void) SetUserName :(NSString*) sName;
{
    [m_pDataPRF WriteString :ACCOUNT_USER_NAME :sName];
}

- (NSString*) GetUserName;
{
    return [m_pDataPRF ReadString :ACCOUNT_USER_NAME :ACCOUNT_USER_NAME_DEFAULT];
}

//////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////

- (void) SetDisplayName :(NSString*) sName;
{
    [m_pDataPRF WriteString :ACCOUNT_DISPLAY_NAME :sName];
}

- (NSString*) GetDisplayName;
{
    return [m_pDataPRF ReadString :ACCOUNT_DISPLAY_NAME :ACCOUNT_DISPLAY_NAME_DEFAULT];
}

//////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////

- (void) SetAuthLogin :(NSString*) sLogin;
{
    [m_pDataPRF WriteString :ACCOUNT_AUTH_LOGIN :sLogin];
}

- (NSString*) GetAuthLogin;
{
    return [m_pDataPRF ReadString :ACCOUNT_AUTH_LOGIN :ACCOUNT_AUTH_LOGIN_DEFAULT];
}

//////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////

- (void) SetAuthPwd :(NSString*) sPwd;
{
    [m_pDataPRF WriteString :ACCOUNT_AUTH_PWD :sPwd];
}

- (NSString*) GetAuthPwd;
{
    return [m_pDataPRF ReadString :ACCOUNT_AUTH_PWD :ACCOUNT_AUTH_PWD_DEFAULT];
}

//////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////

- (void) SetDomainRealm :(NSString*) sDomain;
{
    [m_pDataPRF WriteString :ACCOUNT_DOMAIN_REALM :sDomain];
}

- (NSString*) GetDomainRealm;
{
    return [m_pDataPRF ReadString :ACCOUNT_DOMAIN_REALM :ACCOUNT_DOMAIN_REALM_DEFAULT];
}

//////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////

- (void) SetServerAddr :(NSString*) sAddr;
{
    [m_pDataPRF WriteString :ACCOUNT_SERVER_ADDR :sAddr];
}

- (NSString*) GetServerAddr;
{
    return [m_pDataPRF ReadString :ACCOUNT_SERVER_ADDR :ACCOUNT_SERVER_ADDR_DEFAULT];
}

//////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////

- (void) SetServerPort :(NSString*) sPort;
{
    [m_pDataPRF WriteString :ACCOUNT_SERVER_PORT :sPort];
}

- (NSString*) GetServerPort;
{
    return [m_pDataPRF ReadString :ACCOUNT_SERVER_PORT :ACCOUNT_SERVER_PORT_DEFAULT];
}

//////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////

- (void) SetRegistration :(Boolean) bEnable;
{
    [m_pDataPRF WriteBoolean :ACCOUNT_REGISTRATION :bEnable];
}

- (Boolean) GetRegistration;
{
    return [m_pDataPRF ReadBoolean :ACCOUNT_REGISTRATION :ACCOUNT_REGISTRATION_DEFAULT];
}

//////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////

- (void) SetAccountStatusOnline :(Boolean) bOnline;
{
    [m_pDataPRF WriteBoolean :ACCOUNT_STATUS_ONLINE :bOnline];
}

- (Boolean) GetAccountStatusOnline;
{
    return [m_pDataPRF ReadBoolean :ACCOUNT_STATUS_ONLINE :ACCOUNT_STATUS_ONLINE_DEFAULT];
}

//////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////

@end
