
//  Created by VaxSoft
//  Copyright © 2025 VaxSoft. All rights reserved.

#import "cStoreChatContacts.h"
#import "cDataSQL.h"

#define TABLE_NAME              @"TableChatContacts"

#define COLUMN_RECORD_ID        @"RecordId"
#define COLUMN_NAME             @"Name"
#define COLUMN_MISSED_COUNT     @"MissedCount"
#define COLUMN_PRESENCE         @"Presence"

///////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////

@implementation cStoreDataChatContacts

- (id) init;
{
    self = [super init];
    return self;
}

- (void) dealloc;
{
    
}

@end

///////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////

@implementation cStoreChatContacts

- (id) init;
{
    mpDataSQL = [cDataSQL new];
    
    self = [super init];
    return self;
}

- (void) dealloc;
{
    mpDataSQL = nil;
}

///////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////

- (void) CreateTable;
{
    if(![mpDataSQL OpenDatabase])
        return;
    
    NSString* sQuery = [NSString stringWithFormat :@"CREATE TABLE IF NOT EXISTS '%@' ('%@' INTEGER PRIMARY KEY AUTOINCREMENT, '%@' TEXT, '%@' INTEGER DEFAULT 0, '%@' INTEGER DEFAULT 0)", TABLE_NAME, COLUMN_RECORD_ID, COLUMN_NAME, COLUMN_MISSED_COUNT, COLUMN_PRESENCE];
    
    if(![mpDataSQL StartQuery: sQuery])
    {
        [mpDataSQL CloseDatabase];
        return;
    }
    
    NSMutableArray* pRecordArray = [NSMutableArray new];
    [mpDataSQL GetRowData: pRecordArray];
    
    [mpDataSQL EndQuery];
    [mpDataSQL CloseDatabase];
}

- (void) AddContact :(NSString*) sName :(long) nMissedCount :(Boolean) bPresence;
{
    [self RemoveContact :sName];
    
    if(![mpDataSQL OpenDatabase])
        return;
    
    NSString* sQuery = [NSString stringWithFormat :@"INSERT INTO %@ (%@, %@, %@) VALUES ('%@', %ld, %hhu)", TABLE_NAME, COLUMN_NAME, COLUMN_MISSED_COUNT, COLUMN_PRESENCE, sName, nMissedCount, bPresence];
    
    if(![mpDataSQL StartQuery :sQuery])
    {
        [mpDataSQL CloseDatabase];
        return;
    }
    
    NSMutableArray* pRecordArray = [NSMutableArray new];
    [mpDataSQL GetRowData: pRecordArray];
    [mpDataSQL EndQuery];
    
    [mpDataSQL CloseDatabase];
}

- (void) UpdateMissedCount :(NSString*) sName :(long) nValue;
{
    if(![mpDataSQL OpenDatabase])
        return;
    
    NSString* sQuery = [NSString stringWithFormat :@"UPDATE %@ SET %@ = %ld WHERE %@ = '%@'", TABLE_NAME, COLUMN_MISSED_COUNT, nValue, COLUMN_NAME, sName];
    
    if(![mpDataSQL StartQuery :sQuery])
    {
        [mpDataSQL CloseDatabase];
        return;
    }
    
    NSMutableArray* pRecordArray = [NSMutableArray new];
    [mpDataSQL GetRowData: pRecordArray];
    [mpDataSQL EndQuery];
}

///////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////

- (NSArray*) GetContactAll;
{
    NSMutableArray* pRecordAll = [NSMutableArray new];
    
    if(![mpDataSQL OpenDatabase])
        return pRecordAll;
    
    NSString* sQuery = [NSString stringWithFormat :@"SELECT * FROM %@", TABLE_NAME];
    
    if(![mpDataSQL StartQuery: sQuery])
    {
        [mpDataSQL CloseDatabase];
        return pRecordAll;
    }
    
    while(true)
    {
        NSMutableArray* pRecord = [NSMutableArray new];
        
        if(![mpDataSQL GetRowData: pRecord])
            break;
        
        cStoreDataChatContacts* pData = [cStoreDataChatContacts new];
        
        pData->m_nRecordId = [pRecord[0] integerValue];
        pData->m_sName = pRecord[1];
        pData->m_nMissedCount = [pRecord[2] integerValue];
        pData->m_bPresence = [pRecord[3] boolValue];
        
        [pRecordAll addObject :pData];
    }
    
    [mpDataSQL EndQuery];
    [mpDataSQL CloseDatabase];
    
    return pRecordAll;
}

///////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////

- (void) RemoveContactAll;
{
    if(![mpDataSQL OpenDatabase])
        return;
    
    NSString* sQuery = [NSString stringWithFormat :@"DELETE FROM %@", TABLE_NAME];
    
    if (![mpDataSQL StartQuery: sQuery])
    {
        [mpDataSQL CloseDatabase];
        return;
    }
    
    NSMutableArray* pRecordArray = [NSMutableArray new];
    [mpDataSQL GetRowData: pRecordArray];
    
    [mpDataSQL EndQuery];
    [mpDataSQL CloseDatabase];
}

- (void) RemoveContact :(NSString*) sName;
{
    if(![mpDataSQL OpenDatabase])
        return;
    
    NSString* sQuery = [NSString stringWithFormat :@"DELETE FROM %@ WHERE %@ = '%@'", TABLE_NAME, COLUMN_NAME, sName];
    
    if (![mpDataSQL StartQuery: sQuery])
    {
        [mpDataSQL CloseDatabase];
        return;
    }
    
    NSMutableArray* pRecordArray = [NSMutableArray new];
    [mpDataSQL GetRowData: pRecordArray];
    
    [mpDataSQL EndQuery];
    [mpDataSQL CloseDatabase];
}


///////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////

@end


