
//  Created by VaxSoft
//  Copyright © 2025 VaxSoft. All rights reserved.

#import "cStoreChatMsgs.h"
#import "cDataSQL.h"

#define TABLE_NAME                  @"TableChatMsgs"

#define COLUMN_RECORD_ID            @"RecordId"
#define COLUMN_CONTACT_NAME         @"ContactName"
#define COLUMN_MSG_TEXT             @"MsgText"
#define COLUMN_MSG_TYPE_OUTGOING    @"MsgTypeOutgoing"

///////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////

@implementation cStoreDataChatMsgs

- (id) init;
{
    self = [super init];
    return self;
}

- (void) dealloc;
{
    
}

@end

///////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////

@implementation cStoreChatMsgs

- (id) init;
{
    mpDataSQL = [cDataSQL new];
    
    self = [super init];
    return self;
}

- (void) dealloc;
{
    mpDataSQL = nil;
}

///////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////

- (void) CreateTable;
{
    if(![mpDataSQL OpenDatabase])
        return;
    
    NSString* sQuery = [NSString stringWithFormat :@"CREATE TABLE IF NOT EXISTS '%@' ('%@' INTEGER PRIMARY KEY AUTOINCREMENT, '%@' TEXT, '%@' TEXT, '%@' INTEGER)", TABLE_NAME, COLUMN_RECORD_ID, COLUMN_CONTACT_NAME, COLUMN_MSG_TEXT, COLUMN_MSG_TYPE_OUTGOING];
    
    if(![mpDataSQL StartQuery: sQuery])
    {
        [mpDataSQL CloseDatabase];
        return;
    }
    
    NSMutableArray* pRecordArray = [NSMutableArray new];
    [mpDataSQL GetRowData: pRecordArray];
    
    [mpDataSQL EndQuery];
    [mpDataSQL CloseDatabase];
}

- (void) AddChatMessageText :(NSString*) sContactName :(NSString*) sMsgText :(Boolean) bMsgTypeOutgoing;
{
    if(![mpDataSQL OpenDatabase])
        return;
    
    NSString* sQuery = [NSString stringWithFormat :@"INSERT INTO %@ (%@, %@, %@) VALUES (?, ?, ?)",
                        TABLE_NAME, COLUMN_CONTACT_NAME, COLUMN_MSG_TEXT, COLUMN_MSG_TYPE_OUTGOING];
    
    NSArray* aParam = [NSArray arrayWithObjects: sContactName, sMsgText, [NSNumber numberWithBool :bMsgTypeOutgoing], nil];
    
    if(![mpDataSQL StartQuery :sQuery :aParam])
    {
        [mpDataSQL CloseDatabase];
        return;
    }
    
    NSMutableArray* pRecordArray = [NSMutableArray new];
    [mpDataSQL GetRowData: pRecordArray];
    [mpDataSQL EndQuery];
    
    [mpDataSQL CloseDatabase];
}

///////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////

- (NSArray*) GetChatMessageAll :(NSString*) sContactName;
{
    NSMutableArray* pRecordAll = [NSMutableArray new];
    
    if(![mpDataSQL OpenDatabase])
        return pRecordAll;
    
    NSString* sQuery = [NSString stringWithFormat :@"SELECT * FROM %@ WHERE %@ = '%@'", TABLE_NAME, COLUMN_CONTACT_NAME, sContactName];
    
    if(![mpDataSQL StartQuery: sQuery])
    {
        [mpDataSQL CloseDatabase];
        return pRecordAll;
    }
    
    while(true)
    {
        NSMutableArray* pRecord = [NSMutableArray new];
        
        if(![mpDataSQL GetRowData: pRecord])
            break;
        
        cStoreDataChatMsgs* pData = [cStoreDataChatMsgs new];
        
        pData->m_nRecordId = [pRecord[0] integerValue];
        pData->m_sContactName = pRecord[1];
        pData->m_sMsgText = pRecord[2];
        pData->m_bMsgTypeOutgoing = [pRecord[3] boolValue];
        
        [pRecordAll addObject :pData];
    }
    
    [mpDataSQL EndQuery];
    [mpDataSQL CloseDatabase];
    
    return pRecordAll;
}

///////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////

- (void) RemoveMessageAll :(NSString*) sContactName;
{
    if(![mpDataSQL OpenDatabase])
        return;
    
    NSString* sQuery = [NSString stringWithFormat :@"DELETE FROM %@ WHERE %@ = '%@'", TABLE_NAME, COLUMN_CONTACT_NAME, sContactName];
    
    if (![mpDataSQL StartQuery: sQuery])
    {
        [mpDataSQL CloseDatabase];
        return;
    }
    
    NSMutableArray* pRecordArray = [NSMutableArray new];
    [mpDataSQL GetRowData: pRecordArray];
    
    [mpDataSQL EndQuery];
    [mpDataSQL CloseDatabase];
}

- (void) RemoveMessage :(long) nRecordId;
{
    if(![mpDataSQL OpenDatabase])
        return;
    
    NSString* sQuery = [NSString stringWithFormat :@"DELETE FROM %@ WHERE %@ = '%ld'", TABLE_NAME, COLUMN_RECORD_ID, nRecordId];
    
    if (![mpDataSQL StartQuery: sQuery])
    {
        [mpDataSQL CloseDatabase];
        return;
    }
    
    NSMutableArray* pRecordArray = [NSMutableArray new];
    [mpDataSQL GetRowData: pRecordArray];
    
    [mpDataSQL EndQuery];
    [mpDataSQL CloseDatabase];
}



///////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////

@end


