
//  Created by VaxSoft
//  Copyright © 2025 VaxSoft. All rights reserved.

#import "cStoreNetwork.h"

#define LOCAL_PORT_SIP_KEY                           @"VaxLocalPortSIP"
#define CHOOSE_RANDOMLY_SIP_KEY                      @"VaxChooseRandomlySIP"

#define LOCAL_PORT_SIP_DEFAULT_VALUE                 5060
#define CHOOSE_RANDOMLY_SIP_DEFAULT_VALUE            true

@implementation cStoreNetwork

- (id) init;
{
    m_pDataPRF = [cDataPRF new];
    
    self = [super init];
    return self;
}

- (void) dealloc;
{
    
}

/////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////

- (void) SetLocalPortSIP :(long) nPort;
{
    [m_pDataPRF WriteInteger :LOCAL_PORT_SIP_KEY :nPort];
}

- (void) SetChooseRandomlySIP :(Boolean) bRandomly;
{
    [m_pDataPRF WriteBoolean :CHOOSE_RANDOMLY_SIP_KEY :bRandomly];
}

/////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////

- (long) GetLocalPortSIP;
{
    return [m_pDataPRF ReadInt :LOCAL_PORT_SIP_KEY :LOCAL_PORT_SIP_DEFAULT_VALUE];
}

- (Boolean) GetChooseRandomlySIP;
{
    return [m_pDataPRF ReadBoolean :CHOOSE_RANDOMLY_SIP_KEY :CHOOSE_RANDOMLY_SIP_DEFAULT_VALUE];
}

//////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////

- (void) ResetData;
{
    [m_pDataPRF RemoveKey :LOCAL_PORT_SIP_KEY];
    [m_pDataPRF RemoveKey :CHOOSE_RANDOMLY_SIP_KEY];
}

@end
