
//  Created by VaxSoft
//  Copyright © 2025 VaxSoft. All rights reserved.

#import "cStoreSpKMic.h"

#define AUTO_GAIN_SPK_KEY                   @"VaxAutoGainSpk"
#define AUTO_GAIN_MIC_KEY                   @"VaxAutoGainMic"
#define VOLUME_BOOST_MIC_KEY                @"VaxVolumeBoostMic"

#define AUTO_GAIN_SPK_DEFAULT_VALUE         false
#define AUTO_GAIN_MIC_DEFAULT_VALUE         false
#define VOLUME_BOOST_MIC_DEFAULT_VALUE      false

@implementation cStoreSpKMic

- (id) init;
{
    m_pDataPRF = [cDataPRF new];
    
    self = [super init];
    return self;
}

- (void) dealloc;
{
    
}

- (void) SetAutoGainSpk :(Boolean) bEnable;
{
    [m_pDataPRF WriteBoolean :AUTO_GAIN_SPK_KEY :bEnable];
}

- (void) SetAutoGainMic :(Boolean) bEnable;
{
    [m_pDataPRF WriteBoolean :AUTO_GAIN_MIC_KEY :bEnable];
}

- (void) SetVolumeBoostMic :(Boolean) bEnable;
{
    [m_pDataPRF WriteBoolean :VOLUME_BOOST_MIC_KEY :bEnable];
}

/////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////

- (Boolean) GetAutoGainSpk;
{
    return [m_pDataPRF ReadBoolean :AUTO_GAIN_SPK_KEY :AUTO_GAIN_SPK_DEFAULT_VALUE];
}

- (Boolean) GetAutoGainMic;
{
    return [m_pDataPRF ReadBoolean :AUTO_GAIN_MIC_KEY :AUTO_GAIN_MIC_DEFAULT_VALUE];
}

- (Boolean) GetVolumeBoostMic;
{
    return [m_pDataPRF ReadBoolean:VOLUME_BOOST_MIC_KEY :VOLUME_BOOST_MIC_DEFAULT_VALUE];
}

/////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////

- (void) ResetData;
{
    [m_pDataPRF RemoveKey :AUTO_GAIN_SPK_KEY];
    
    [m_pDataPRF RemoveKey :AUTO_GAIN_MIC_KEY];
    [m_pDataPRF RemoveKey :VOLUME_BOOST_MIC_KEY];
}

@end
