
//  Created by VaxSoft
//  Copyright © 2025 VaxSoft. All rights reserved.

#import "cVaxPhoneSIP.h"
#import "cStoreVideoCodecs.h"

#define VIDEO_CODEC_NO_KEY          @"VaxVideoCodecNo"
#define VIDEO_CODEC_ENABLED_KEY     @"VaxVideoCodecEnabled"

@implementation cStoreVideoCodecs

- (id) init;
{
    m_pDataPRF = [cDataPRF new];
    
    maDefaultCodecNo = [NSArray arrayWithObjects:
                        [NSNumber numberWithLong :VAX_VIDEO_CODEC_VP8], nil];
                           
    maDefaultCodecEnabled[VAX_VIDEO_CODEC_VP8] = true;
    
    self = [super init];
    return self;
}

- (void) dealloc;
{
    
}

//////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////

- (void) SetVideoCodec :(NSArray*) aCodecNo;
{
    [m_pDataPRF WriteArray :VIDEO_CODEC_NO_KEY :aCodecNo];
}

- (void) GetVideoCodec :(NSMutableArray*) aCodecNo;
{
    NSArray* aReadCodecNo = [m_pDataPRF ReadArray :VIDEO_CODEC_NO_KEY :maDefaultCodecNo];
    
    if(aReadCodecNo.count != VAX_VIDEO_CODEC_TOTAL)
    {
        aReadCodecNo = maDefaultCodecNo;
    }
    
    for(int nCount = 0; nCount < [aReadCodecNo count]; nCount++)
        [aCodecNo addObject :[aReadCodecNo objectAtIndex :nCount]];
}

//////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////

- (void) SetVideoCodecEnabled :(long) nCodecNo :(Boolean) bEnable;
{
    NSString* sKey = [NSString stringWithFormat: @"%@:%ld", VIDEO_CODEC_ENABLED_KEY, nCodecNo];
    [m_pDataPRF WriteBoolean :sKey :bEnable];
}

- (Boolean) GetVideoCodecEnabled :(long) nCodecNo;
{
    NSString* sKey = [NSString stringWithFormat: @"%@:%ld", VIDEO_CODEC_ENABLED_KEY, nCodecNo];
    return [m_pDataPRF ReadBoolean :sKey :maDefaultCodecEnabled[nCodecNo]];
}

/////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////

- (void) ResetData;
{
    [m_pDataPRF RemoveKey :VIDEO_CODEC_NO_KEY];
    
    for(long nCodecNo = 0; nCodecNo < VAX_VIDEO_CODEC_TOTAL; nCodecNo++)
    {
        NSString* sKey = [NSString stringWithFormat: @"%@:%ld", VIDEO_CODEC_ENABLED_KEY, nCodecNo];
        [m_pDataPRF RemoveKey :sKey];
    }
}

@end

