#import "cVaxUserAgentFrwSIP.h"
#import "cVaxUserAgentSIP.h"
#import <AVFoundation/AVFoundation.h>

@implementation cVaxUserAgentFrwSIP

- (id) init;
{
    mPushKit = [[cVaxPushKit alloc] initWith :self];
    
    self = [super init];
    return self;
}

- (void) dealloc;
{
    mPushKit = NULL;
}

/////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////

- (Boolean) RegisterAccountPushKit :(NSString*) sAccountName :(int) nExpire;
{
    #if TARGET_IPHONE_SIMULATOR
        if(![super RegisterAccountSIP :sAccountName :nExpire])
        {
            return false;
        }
    #else
        [mPushKit Start];
    #endif
    
   return true;
}

/////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////

- (Boolean) IsSpeakerPhone;
{
    if([AVAudioSession sharedInstance] == nil)
        return false;
    
    if([AVAudioSession sharedInstance].currentRoute == nil)
        return false;
    
    if([AVAudioSession sharedInstance].currentRoute.outputs == nil)
        return false;
    
    if([[AVAudioSession sharedInstance].currentRoute.outputs count] == 0)
        return false;
    
    AVAudioSessionPortDescription* PortRoute = [AVAudioSession sharedInstance].currentRoute.outputs[0];
    
    if ([PortRoute.portType caseInsensitiveCompare :@"Speaker"] != NSOrderedSame)
    {
        return false;
    }
    
    /*
     
     AVAudioSessionRouteDescription* CurrentRoute = [AVAudioSession sharedInstance].currentRoute;
     
     for (AVAudioSessionPortDescription *portDesc in [[[AVAudioSession sharedInstance] currentRoute] outputs])
     {
        NSLog(@"-----");
        NSLog(@"portDesc UID %@", portDesc.UID);
        NSLog(@"portDesc portName %@", portDesc.portName);
        NSLog(@"portDesc portType %@", portDesc.portType);
        NSLog(@"portDesc channels %@", portDesc.channels);
     }
     */

    return true;
}

- (Boolean) SpeakerPhone :(Boolean) bEnable;
{
    if(bEnable)
    {
        [[AVAudioSession sharedInstance] overrideOutputAudioPort:AVAudioSessionPortOverrideSpeaker error:nil];
    }
    else
    {
        [[AVAudioSession sharedInstance] overrideOutputAudioPort:AVAudioSessionPortOverrideNone error:nil];
    }
    
    return true;
}

/////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////

- (void) OnVaxTryingPushKit;
{
    [cVaxUserAgentSIP OnVaxRegisterTryingPushKit];
}

- (void) OnVaxFailedPushKit;
{
    [cVaxUserAgentSIP OnVaxRegisterFailedPushKit];
}

- (void) OnVaxSuccessPushKit :(NSString*) sDeviceToken;
{
    [cVaxUserAgentSIP OnVaxRegisterSuccessPushKit :sDeviceToken];
}

- (void) OnVaxNotificationPushKit :(NSString*) sCallerName :(NSString*) sCallerId;
{
    [cVaxUserAgentSIP OnVaxNotificationPushKit :sCallerName :sCallerId];
}

/////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////

- (void) OnInitialized;
{
    [cVaxUserAgentSIP OnInitialized];
}

- (void) OnUnInitialized;
{
    [cVaxUserAgentSIP OnUnInitialized];
}

/////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////

- (void) OnConnectingToRegister :(NSString*) sAccountName;
{
    [cVaxUserAgentSIP OnConnectingToRegister :sAccountName];
}

- (void) OnTryingToRegister :(NSString*) sAccountName;
{
    [cVaxUserAgentSIP OnTryingToRegister :sAccountName];
}

- (void) OnFailToRegister :(NSString*) sAccountName :(int) nStatusCode :(NSString*) sReasonPhrase;
{
    [cVaxUserAgentSIP OnFailToRegister :sAccountName :nStatusCode :sReasonPhrase];
}

- (void) OnSuccessToRegister :(NSString*) sAccountName;
{
    [cVaxUserAgentSIP OnSuccessToRegister :sAccountName];
}

- (void) OnConnectingToReRegister :(NSString*) sAccountName;
{
    [cVaxUserAgentSIP OnConnectingToReRegister :sAccountName];
}

- (void) OnTryingToReRegister :(NSString*) sAccountName;
{
    [cVaxUserAgentSIP OnTryingToReRegister :sAccountName];
}

- (void) OnFailToReRegister :(NSString*) sAccountName :(int) nStatusCode :(NSString*) sReasonPhrase;
{
    [cVaxUserAgentSIP OnFailToReRegister :sAccountName :nStatusCode :sReasonPhrase];
}

- (void) OnSuccessToReRegister :(NSString*) sAccountName;
{
    [cVaxUserAgentSIP OnSuccessToReRegister :sAccountName];
}
    
- (void) OnTryingToUnRegister :(NSString*) sAccountName;
{
    [cVaxUserAgentSIP OnTryingToUnRegister :sAccountName];
}

- (void) OnFailToUnRegister :(NSString*) sAccountName;
{
    [cVaxUserAgentSIP OnFailToUnRegister :sAccountName];
}

- (void) OnSuccessToUnRegister :(NSString*) sAccountName;
{
    [cVaxUserAgentSIP OnSuccessToUnRegister :sAccountName];
}
        
/////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////

- (void) OnDialCallStarted :(NSString*) sAccountName :(int) nLineNo :(NSString*) sCallerName :(NSString*) sCallerId :(NSString*) sDialNo;
{
    [cVaxUserAgentSIP OnDialCallStarted :sAccountName :nLineNo :sCallerName :sCallerId :sDialNo];
}

- (void) OnDialingCall :(NSString*) sAccountName :(int) nLineNo :(int) nStatusCode :(NSString*) sReasonPhrase;
{
    [cVaxUserAgentSIP OnDialingCall :sAccountName :nLineNo :nStatusCode :sReasonPhrase];
}

- (void) OnDialCallFailed :(NSString*) sAccountName :(int) nLineNo :(int) nStatusCode :(NSString*) sReasonPhrase :(NSString*) sContact;
{
    [cVaxUserAgentSIP OnDialCallFailed :sAccountName :nLineNo :nStatusCode :sReasonPhrase :sContact];
}

- (void) OnConnectedCall :(NSString*) sAccountName :(int) nLineNo :(NSString*) sToAddrRTP :(int) nToPortRTP;
{
    [cVaxUserAgentSIP OnConnectedCall :sAccountName :nLineNo :sToAddrRTP :nToPortRTP];
}

- (void) OnHungupCall :(NSString*) sAccountName :(int) nLineNo;
{
    [cVaxUserAgentSIP OnHungupCall :sAccountName :nLineNo];
}

- (void) OnIncomingCallStarted :(NSString*) sAccountName :(NSString*) sCallId :(NSString*) sCallerName :(NSString*) sCallerId :(NSString*) sDialNo :(NSString*) sFromURI :(NSString*) sToURI;
{
    [cVaxUserAgentSIP OnIncomingCallStarted :sAccountName :sCallId :sCallerName :sCallerId :sDialNo :sFromURI :sToURI];
}

- (void) OnIncomingCallEnded :(NSString*) sAccountName :(NSString*) sCallId :(int) nReasonCode;
{
    [cVaxUserAgentSIP OnIncomingCallEnded :sAccountName :sCallId :nReasonCode];
}
    
/////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////

- (void) OnTransferCallFailed :(NSString*) sAccountName :(int) nLineNo :(int) nStatusCode :(NSString*) sReasonPhrase;
{
    [cVaxUserAgentSIP OnTransferCallFailed :sAccountName :nLineNo :nStatusCode :sReasonPhrase];
}

- (void) OnTransferCallAccepted :(NSString*) sAccountName :(int) nLineNo;
{
    [cVaxUserAgentSIP OnTransferCallAccepted :sAccountName :nLineNo];
}

- (void) OnPlayWaveDone :(NSString*) sAccountName :(int) nLineNo;
{
    [cVaxUserAgentSIP OnPlayWaveDone :sAccountName :nLineNo];
}

- (void) OnDigitDTMF :(NSString*) sAccountName :(int) nLineNo :(NSString*) sDigit;
{
    [cVaxUserAgentSIP OnDigitDTMF :sAccountName :nLineNo :sDigit];
}
    
- (void) OnMsgNOTIFY :(NSString*) sAccountName :(NSString*) sMsg;
{
    [cVaxUserAgentSIP OnMsgNOTIFY :sAccountName :sMsg];
}

- (void) OnVoiceMailMsg :(NSString*) sAccountName :(Boolean) bIsMsgWaiting :(int) nNewMsgCount :(int) nOldMsgCount :(int) nNewUrgentMsgCount :(int) nOldUrgentMsgCount :(NSString*) sMsgAccount;
{
    [cVaxUserAgentSIP OnVoiceMailMsg :sAccountName :bIsMsgWaiting :nNewMsgCount :nOldMsgCount :nNewUrgentMsgCount :nOldUrgentMsgCount :sMsgAccount];
}
                
- (void) OnRingToneStarted :(NSString*) sAccountName :(NSString*) sCallId;
{
    [cVaxUserAgentSIP OnRingToneStarted :sAccountName :sCallId];
}

- (void) OnRingToneEnded :(NSString*) sAccountName :(NSString*) sCallId;
{
    [cVaxUserAgentSIP OnRingToneEnded :sAccountName :sCallId];
}
        
- (void) OnIncomingDiagnostic :(NSString*) sAccountName :(NSString*) sMsgSIP :(NSString*) sFromIP :(int) nFromPort;
{
    [cVaxUserAgentSIP OnIncomingDiagnostic :sAccountName :sMsgSIP :sFromIP :nFromPort];
}

- (void) OnOutgoingDiagnostic :(NSString*) sAccountName :(NSString*) sMsgSIP :(NSString*) sToIP :(int) nToPort;
{
    [cVaxUserAgentSIP OnOutgoingDiagnostic :sAccountName :sMsgSIP :sToIP :nToPort];
}

- (void) OnAudioSessionLost :(NSString*) sAccountName :(int) nLineNo;
{
    [cVaxUserAgentSIP OnAudioSessionLost :sAccountName :nLineNo];
}
    
- (void) OnSuccessToHold :(NSString*) sAccountName :(int) nLineNo;
{
    [cVaxUserAgentSIP OnSuccessToHold :sAccountName :nLineNo];
}

- (void) OnTryingToHold :(NSString*) sAccountName :(int) nLineNo;
{
    [cVaxUserAgentSIP OnTryingToHold :sAccountName :nLineNo];
}

- (void) OnFailToHold :(NSString*) sAccountName :(int) nLineNo;
{
    [cVaxUserAgentSIP OnFailToHold :sAccountName :nLineNo];
}

- (void) OnSuccessToUnHold :(NSString*) sAccountName :(int) nLineNo;
{
    [cVaxUserAgentSIP OnSuccessToUnHold :sAccountName :nLineNo];
}

- (void) OnTryingToUnHold :(NSString*) sAccountName :(int) nLineNo;
{
    [cVaxUserAgentSIP OnTryingToUnHold :sAccountName :nLineNo];
}

- (void) OnFailToUnHold :(NSString*) sAccountName :(int) nLineNo;
{
    [cVaxUserAgentSIP OnFailToUnHold :sAccountName :nLineNo];
}

- (void) OnTryingToRefresh :(NSString*) sAccountName :(int) nLineNo;
{
    [cVaxUserAgentSIP OnTryingToRefresh :sAccountName :nLineNo];
}

- (void) OnFailToRefresh :(NSString*) sAccountName :(int) nLineNo;
{
    [cVaxUserAgentSIP OnFailToRefresh :sAccountName :nLineNo];
}

- (void) OnSuccessToRefresh :(NSString*) sAccountName :(int) nLineNo;
{
    [cVaxUserAgentSIP OnSuccessToRefresh :sAccountName :nLineNo];
}

- (void) OnChatSubscribeSuccess :(NSString*) sAccountName :(NSString*) sUserName;
{
    [cVaxUserAgentSIP OnChatSubscribeSuccess :sAccountName :sUserName];
}

- (void) OnChatSubscribeFailed :(NSString*) sAccountName :(NSString*) sUserName :(int) nStatusCode :(NSString*) sReasonPhrase;
{
    [cVaxUserAgentSIP OnChatSubscribeFailed :sAccountName :sUserName :nStatusCode :sReasonPhrase];
}

- (void) OnChatContactStatus :(NSString*) sAccountName :(NSString*) sUserName :(int) nStatusId;
{
    [cVaxUserAgentSIP OnChatContactStatus :sAccountName :sUserName :nStatusId];
}
        
- (void) OnChatSendMsgTextSuccess :(NSString*) sAccountName :(NSString*) sUserName :(NSString*) sMsgText :(long) nUserValue;
{
    [cVaxUserAgentSIP OnChatSendMsgTextSuccess :sAccountName :sUserName :sMsgText :nUserValue];
}

- (void) OnChatSendMsgTextFailed :(NSString*) sAccountName :(NSString*) sUserName :(int) nStatusCode :(NSString*) sReasonPhrase :(NSString*) sMsgText :(long) nUserValue;
{
    [cVaxUserAgentSIP OnChatSendMsgTextFailed :sAccountName :sUserName :nStatusCode :sReasonPhrase :sMsgText :nUserValue];
}
    
- (void) OnChatSendMsgTypingSuccess :(NSString*) sAccountName :(NSString*) sUserName :(long) nUserValue;
{
    [cVaxUserAgentSIP OnChatSendMsgTypingSuccess :sAccountName :sUserName :nUserValue];
}

- (void) OnChatSendMsgTypingFailed :(NSString*) sAccountName :(NSString*) sUserName :(int) nStatusCode :(NSString*) sReasonPhrase :(long) nUserValue;
{
    [cVaxUserAgentSIP OnChatSendMsgTypingFailed :sAccountName :sUserName :nStatusCode :sReasonPhrase :nUserValue];
}

- (void) OnChatRecvMsgText :(NSString*) sAccountName :(NSString*) sUserName :(NSString*) sMsgText :(Boolean) bIsChatContact;
{
    [cVaxUserAgentSIP OnChatRecvMsgText :sAccountName :sUserName :sMsgText :bIsChatContact];
}

- (void) OnChatRecvMsgTypingStart :(NSString*) sAccountName :(NSString*) sUserName;
{
    [cVaxUserAgentSIP OnChatRecvMsgTypingStart :sAccountName :sUserName];
}

- (void) OnChatRecvMsgTypingStop :(NSString*) sAccountName :(NSString*) sUserName;
{
    [cVaxUserAgentSIP OnChatRecvMsgTypingStop :sAccountName :sUserName];
}

- (void) OnAudioRecordedPCM :(NSString*) sAccountName :(int) nLineNo :(char*) pDataPCM :(int) nSizePCM :(int) nTypePCM;
{
    [cVaxUserAgentSIP OnAudioRecordedPCM :sAccountName :nLineNo :pDataPCM :nSizePCM :nTypePCM];
}

- (void) OnHoldCall :(NSString*) sAccountName :(int) nLineNo;
{
    [cVaxUserAgentSIP OnHoldCall :sAccountName :nLineNo];
}

- (void) OnUnHoldCall :(NSString*) sAccountName :(int) nLineNo;
{
    [cVaxUserAgentSIP OnUnHoldCall :sAccountName :nLineNo];
}

- (void) OnVideoRemoteStarted :(NSString*) sAccountName :(int) nLineNo;
{
    [cVaxUserAgentSIP OnVideoRemoteStarted :sAccountName :nLineNo];
}

- (void) OnVideoRemoteEnded :(NSString*) sAccountName :(int) nLineNo;
{
    [cVaxUserAgentSIP OnVideoRemoteEnded :sAccountName :nLineNo];
}
    
- (void) OnVideoDeviceFrameRGB :(int) nDeviceId :(char*) pFrameRGB :(int) nFrameSize :(int) nFrameWidth :(int) nFrameHeight;
{
    [cVaxUserAgentSIP OnVideoDeviceFrameRGB :nDeviceId :pFrameRGB :nFrameSize :nFrameWidth :nFrameHeight];
}

- (void) OnVideoRemoteFrameRGB :(NSString*) sAccountName :(int) nLineNo :(char*) pFrameRGB :(int) nFrameSize :(int) nFrameWidth :(int) nFrameHeight;
{
    [cVaxUserAgentSIP OnVideoRemoteFrameRGB :sAccountName :nLineNo :pFrameRGB :nFrameSize :nFrameWidth :nFrameHeight];
}
            
- (void) OnAddCallHistory :(NSString*) sAccountName :(Boolean) bOutboundCallType :(NSString*) sCallerName :(NSString*) sCallerId :(NSString*) sDialNo :(long) nStartTime :(long) nEndTime :(long) nDuration :(long) nDayNo :(int) nHistoryTypeId;
{
    [cVaxUserAgentSIP OnAddCallHistory :sAccountName :bOutboundCallType :sCallerName :sCallerId :sDialNo :nStartTime :nEndTime :nDuration :nDayNo :nHistoryTypeId];
}

- (void) OnNetworkReachability :(Boolean) bAvailable;
{
    [cVaxUserAgentSIP OnNetworkReachability :bAvailable];
}

- (void) OnAudioDeviceMicVU :(int) nLevelVU;
{
    [cVaxUserAgentSIP OnAudioDeviceMicVU :nLevelVU];
}

- (void) OnAudioDeviceSpkVU :(int) nLevelVU;
{
    [cVaxUserAgentSIP OnAudioDeviceSpkVU :nLevelVU];
}

- (void) OnBusyLampSubscribeSuccess :(NSString*) sAccountName :(NSString*) sUserName;
{
    [cVaxUserAgentSIP OnBusyLampSubscribeSuccess :sAccountName :sUserName];
}

- (void) OnBusyLampSubscribeFailed :(NSString*) sAccountName :(NSString*) sUserName :(int) nStatusCode :(NSString*) sReasonPhrase;
{
    [cVaxUserAgentSIP OnBusyLampSubscribeFailed :sAccountName :sUserName :nStatusCode :sReasonPhrase];
}

- (void) OnBusyLampContactStatus :(NSString*) sAccountName :(NSString*) sUserName :(int) nStatusId;
{
    [cVaxUserAgentSIP OnBusyLampContactStatus :sAccountName :sUserName :nStatusId];
}

- (void) OnVaxErrorMsg :(NSString*) sFuncName :(NSString*) sErrorMsg :(int) nErrorCode;
{
    [cVaxUserAgentSIP OnVaxErrorMsg :sFuncName :sErrorMsg :nErrorCode];
}

@end;

