#import "cVaxUserAgentSIP.h"
#import "cVaxUserAgentFrwSIP.h"
#import "cVaxCallInfo.h"

static cVaxUserAgentFrwSIP* mAgentFrwSIP = nil;
static NSMutableArray* mListDelegate = nil;

@implementation cVaxUserAgentSIP
@synthesize mVaxAgentDelegate;

- (id)initWith :(id) iDelegate;
{
    self = [super init];
    
    mVaxAgentDelegate = iDelegate;
    
    if(mAgentFrwSIP == nil)
    {
        mAgentFrwSIP = [[cVaxUserAgentFrwSIP alloc] init];
    }
    
    if(mListDelegate == nil)
    {
        mListDelegate = [NSMutableArray new];
    }
    
    if(mVaxAgentDelegate != nil)
        [mListDelegate addObject: mVaxAgentDelegate];
    
    return self;
}

- (void) dealloc;
{
    if(mVaxAgentDelegate == nil)
        return;
    
    if(mListDelegate != nil)
        [mListDelegate removeObject: mVaxAgentDelegate];
    
    mVaxAgentDelegate = nil;
    
    /*
    for (int nIndex = 0; nIndex < [mListDelegate count]; nIndex++)
    {
        id <iVaxUserAgentSIP> vDelegate = [mListDelegate objectAtIndex:nIndex];
        
        if(mVaxAgentDelegate == vDelegate)
        {
            [mListDelegate removeObject: mVaxAgentDelegate]
        }
       
    }
     */
}

//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////

- (NSString*) GetVersionFile;
{
    return [mAgentFrwSIP GetVersionFile];
}

- (NSString*) GetVersionSDK;
{
    return [mAgentFrwSIP GetVersionSDK];
}

- (Boolean) SetLicenceKey :(NSString*) sLicenceKey;
{
    return [mAgentFrwSIP SetLicenceKey :sLicenceKey];
}

- (NSString*) GetCallId :(int) nLineNo;
{
    return [mAgentFrwSIP GetCallId :nLineNo];
}

- (Boolean) Initialize;
{
    return [mAgentFrwSIP Initialize];
}

//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////

- (void) UnInitialize;
{
    [mAgentFrwSIP UnInitialize];
}

//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////

- (Boolean) AddAccountSIP :(NSString*) sAccountName :(int) nAccountType :(NSString*) sListenIP :(int) nListenPort :(NSString*) sDisplayName :(NSString*) sUserName :(NSString*) sAuthLogin :(NSString*) sAuthPwd :(NSString*) sDomainRealm :(NSString*) sServerAddr :(int) nServerPort;
{
    return [mAgentFrwSIP AddAccountSIP :sAccountName :nAccountType :sListenIP :nListenPort :sDisplayName :sUserName :sAuthLogin :sAuthPwd :sDomainRealm :sServerAddr :nServerPort];
}

- (void) RemoveAccountSIP :(NSString*) sAccountName;
{
    [mAgentFrwSIP RemoveAccountSIP :sAccountName];
}

//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////

- (Boolean) DialCall :(NSString*) sAccountName :(int) nLineNo :(NSString*) sCallerName :(NSString*) sCallerId :(NSString*) sDialNo;
{
    return [mAgentFrwSIP DialCall :sAccountName :nLineNo :sCallerName :sCallerId :sDialNo :-1 :-1];
}

- (Boolean) DialCallToREC :(NSString*) sAccountName :(int) nLineNo :(NSString*) sDialNo;
{
    return [mAgentFrwSIP DialCallToREC :sAccountName :nLineNo :sDialNo];
}

- (Boolean) DisconnectCall :(int) nLineNo;
{
    if(![mAgentFrwSIP DisconnectCall :nLineNo])
        return false;
    
    [cVaxUserAgentSIP OnDisconnectedCall :nLineNo];
    return true;
}

//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////

- (Boolean) AcceptCall :(int) nLineNo;
{
    return [mAgentFrwSIP AcceptCall :nLineNo :@"" :-1 :-1];
}

- (Boolean) RejectCall;
{
    return [mAgentFrwSIP RejectCall :@""];
}

//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////

- (Boolean) TransferCallBlind :(int) nLineNo :(NSString*) sToUserName;
{
    return [mAgentFrwSIP TransferCallBlind :nLineNo :sToUserName];
}

- (Boolean) TransferCallConsult :(int) nLineNoA :(int) nLineNoB;
{
    return [mAgentFrwSIP TransferCallConsult :nLineNoA: nLineNoB];
}

//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////

- (Boolean) HoldLine :(int) nLineNo;
{
    return [mAgentFrwSIP HoldLine :nLineNo];
}

- (Boolean) UnHoldLine :(int) nLineNo;
{
    return [mAgentFrwSIP UnHoldLine :nLineNo];
}

- (Boolean) RefreshLine :(int) nLineNo;
{
    return [mAgentFrwSIP RefreshLine :nLineNo];
}

//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////

- (Boolean) RegisterAccountPushKit :(NSString*) sAccountName :(int) nExpire;
{
    return [mAgentFrwSIP RegisterAccountPushKit :sAccountName :nExpire];
}

- (Boolean) RegisterAccountSIP :(NSString*) sAccountName :(int) nExpire;
{
    return [mAgentFrwSIP RegisterAccountSIP :sAccountName :nExpire];
}

- (Boolean) UnRegisterAccountSIP :(NSString*) sAccountName;
{
    return [mAgentFrwSIP UnRegisterAccountSIP :sAccountName];
}

//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////

- (Boolean) EnableKeepAlive :(NSString*) sAccountName :(int) nSeconds;
{
    return [mAgentFrwSIP EnableKeepAlive :sAccountName :nSeconds];
}

- (void) DisableKeepAlive :(NSString*) sAccountName;
{
    [mAgentFrwSIP DisableKeepAlive :sAccountName];
}

//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////

- (void) DeselectAllAudioCodec;
{
    [mAgentFrwSIP DeselectAllAudioCodec];
}

- (void) SelectAllAudioCodec;
{
    [mAgentFrwSIP SelectAllAudioCodec];
}

- (Boolean) SelectAudioCodec :(int) nCodecNo;
{
    return [mAgentFrwSIP SelectAudioCodec :nCodecNo];
}

- (Boolean) DeselectAudioCodec :(int) nCodecNo;
{
    return [mAgentFrwSIP DeselectAudioCodec :nCodecNo];
}

//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////

- (void) DeselectAllVideoCodec;
{
    [mAgentFrwSIP DeselectAllVideoCodec];
}

- (void) SelectAllVideoCodec;
{
    [mAgentFrwSIP SelectAllVideoCodec];
}

- (Boolean) SelectVideoCodec :(int) nCodecNo;
{
    return [mAgentFrwSIP SelectVideoCodec :nCodecNo];
}

- (Boolean) DeselectVideoCodec :(int) nCodecNo;
{
    return [mAgentFrwSIP DeselectVideoCodec :nCodecNo];
}

//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////

- (Boolean) OpenLineREC :(int) nLineNo :(NSString*) sRTPRxIP :(int) nAudioPortRTP;
{
    return [mAgentFrwSIP OpenLineREC :nLineNo :sRTPRxIP :nAudioPortRTP];
}

- (Boolean) OpenLine :(int) nLineNo :(NSString*) sRTPRxIP :(int) nRxAudioPortRTP :(int) nRxVideoPortRTP;
{
    return [mAgentFrwSIP OpenLine :nLineNo :sRTPRxIP :nRxAudioPortRTP: nRxVideoPortRTP];
}

- (Boolean) CloseLine :(int) nLineNo;
{
    return [mAgentFrwSIP CloseLine :nLineNo];
}

////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////

- (Boolean) IsSpeakerPhone;
{
    return [mAgentFrwSIP IsSpeakerPhone];
}

- (Boolean) SpeakerPhone :(Boolean) bEnable;
{
    return [mAgentFrwSIP SpeakerPhone :bEnable];
}

//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////

- (Boolean) CryptoMediaNONE :(Boolean) bForced;
{
    return [mAgentFrwSIP CryptoMediaNONE :bForced];
}

- (Boolean) CryptoMediaSDP :(Boolean) bForced;
{
    return [mAgentFrwSIP CryptoMediaSDP :bForced];
}

//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////

- (int) GetVaxErrorCode;
{
    return [mAgentFrwSIP GetVaxErrorCode];
}

- (NSString*) GetVaxErrorMsg;
{
    return [mAgentFrwSIP GetVaxErrorMsg];
}

- (Boolean) DigitDTMF :(int) nLineNo :(NSString*) sDigit :(int) nTypeDTMF;
{
    return [mAgentFrwSIP DigitDTMF :nLineNo :sDigit :nTypeDTMF];
}

- (Boolean) SetVolumeDTMF :(int) nVolume;
{
    return [mAgentFrwSIP SetVolumeDTMF :nVolume];
}

- (int) GetVolumeDTMF;
{
    return [mAgentFrwSIP GetVolumeDTMF];
}

/////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////

- (Boolean) MuteMic :(Boolean) bMute;
{
    return [mAgentFrwSIP MuteMic :bMute];
}

- (Boolean) MuteSpk :(Boolean) bMute;
{
    return [mAgentFrwSIP MuteSpk :bMute];
}
    
- (Boolean) MuteLineSpk :(int) nLineNo :(Boolean) bMute;
{
    return [mAgentFrwSIP MuteLineSpk :nLineNo: bMute];
}

- (Boolean) MuteLineMic :(int) nLineNo :(Boolean) bMute;
{
    return [mAgentFrwSIP MuteLineMic :nLineNo: bMute];
}
        
- (Boolean) AutoGainMic :(Boolean) bEnable :(int) nVolume;
{
    return [mAgentFrwSIP AutoGainMic :bEnable: nVolume];
}

- (Boolean) AutoGainSpk :(Boolean) bEnable :(int) nVolume;
{
    return [mAgentFrwSIP AutoGainSpk :bEnable: nVolume];
}
            
- (Boolean) SetVolumeMic :(int) nVolume;
{
    return [mAgentFrwSIP SetVolumeMic :nVolume];
}

- (int) GetVolumeMic;
{
    return [mAgentFrwSIP GetVolumeMic];
}

- (Boolean) SetVolumeSpk :(int) nVolume;
{
    return [mAgentFrwSIP SetVolumeSpk :nVolume];
}

- (int) GetVolumeSpk;
{
    return [mAgentFrwSIP GetVolumeSpk];
}
            
- (Boolean) SetLineVolumeSpk :(int) nLineNo :(int) nVolume;
{
    return [mAgentFrwSIP SetLineVolumeSpk :nLineNo: nVolume];
}

- (int) GetLineVolumeSpk :(int) nLineNo;
{
    return [mAgentFrwSIP GetLineVolumeSpk :nLineNo];
}

/////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////

- (Boolean) IsLineOpen :(int) nLineNo;
{
    return [mAgentFrwSIP IsLineOpen :nLineNo];
}

- (Boolean) IsLineHold :(int) nLineNo;
{
    return [mAgentFrwSIP IsLineHold :nLineNo];
}

- (Boolean) IsLineBusy :(int) nLineNo;
{
    return [mAgentFrwSIP IsLineBusy :nLineNo];
}

- (Boolean) IsLineConnected :(int) nLineNo;
{
    return [mAgentFrwSIP IsLineConnected :nLineNo];
}

- (Boolean) IsLineRecording :(int) nLineNo;
{
    return [mAgentFrwSIP IsLineRecording :nLineNo];
}

- (Boolean) StartRecording :(int) nLineNo :(NSString*) sFileName :(int) nTypeRecord :(int) nTypePCM;
{
    return [mAgentFrwSIP StartRecording :nLineNo :sFileName :nTypeRecord: nTypePCM];
}

- (Boolean) StopRecording :(int) nLineNo;
{
    return [mAgentFrwSIP StopRecording :nLineNo];
}

- (Boolean) ResetRecording :(int) nLineNo;
{
    return [mAgentFrwSIP ResetRecording :nLineNo];
}

- (Boolean) IsLinePlaying :(int) nLineNo;
{
    return [mAgentFrwSIP IsLinePlaying :nLineNo];
}

- (Boolean) PlayWaveOpen :(int) nLineNo :(NSString*) sFileName;
{
    return [mAgentFrwSIP PlayWaveOpen :nLineNo :sFileName];
}

- (Boolean) PlayWaveClose :(int) nLineNo;
{
    return [mAgentFrwSIP PlayWaveClose :nLineNo];
}

- (Boolean) PlayWaveSkipTo :(int) nLineNo :(int) nMilliSeconds;
{
    return [mAgentFrwSIP PlayWaveSkipTo :nLineNo: nMilliSeconds];
}

- (int) PlayWaveTotalTime :(int) nLineNo;
{
    return [mAgentFrwSIP PlayWaveTotalTime :nLineNo];
}

- (Boolean) PlayWavePause :(int) nLineNo;
{
    return [mAgentFrwSIP PlayWavePause :nLineNo];
}

- (Boolean) PlayWaveStart :(int) nLineNo :(Boolean) bListen;
{
    return [mAgentFrwSIP PlayWaveStart :nLineNo: bListen];
}

- (Boolean) PlayWaveStop :(int) nLineNo;
{
    return [mAgentFrwSIP PlayWaveStop :nLineNo];
}

- (int) PlayWavePosition :(int) nLineNo;
{
    return [mAgentFrwSIP PlayWavePosition :nLineNo];
}

- (Boolean) EchoCancellation :(Boolean) bEnable;
{
    return [mAgentFrwSIP EchoCancellation :bEnable];
}

- (Boolean) DonotDisturb :(Boolean) bEnable;
{
    return [mAgentFrwSIP DonotDisturb :bEnable];
}

- (Boolean) AudioDeviceVU :(Boolean) bActivate :(Boolean) bMicVU :(Boolean) bSpkVU;
{
    return [mAgentFrwSIP AudioDeviceVU :bActivate: bMicVU: bSpkVU];
}

- (int) GetAudioInDevTotal;
{
    return [mAgentFrwSIP GetAudioInDevTotal];
}

- (int) GetAudioOutDevTotal;
{
    return [mAgentFrwSIP GetAudioOutDevTotal];
}

- (NSString*) GetAudioOutDevName :(int) nDeviceId;
{
    return [mAgentFrwSIP GetAudioOutDevName :nDeviceId];
}

- (NSString*) GetAudioInDevName :(int) nDeviceId;
{
    return [mAgentFrwSIP GetAudioInDevName :nDeviceId];
}

- (int) GetOutboundCodec :(int) nLineNo;
{
    return [mAgentFrwSIP GetOutboundCodec :nLineNo];
}
    
- (int) GetInboundCodec :(int) nLineNo;
{
    return [mAgentFrwSIP GetInboundCodec :nLineNo];
}

- (Boolean) AudioSessionLost :(int) nSeconds;
{
    return [mAgentFrwSIP AudioSessionLost :nSeconds];
}

- (Boolean) SetUserAgentSIP :(NSString*) sUserAgentName;
{
    return [mAgentFrwSIP SetUserAgentSIP :sUserAgentName];
}

- (NSString*) GetUserAgentSIP;
{
    return [mAgentFrwSIP GetUserAgentSIP];
}

- (Boolean) SetSubjectSDP :(NSString*) sSubjectSDP;
{
    return [mAgentFrwSIP SetSubjectSDP :sSubjectSDP];
}

- (NSString*) GetSubjectSDP;
{
    return [mAgentFrwSIP GetSubjectSDP];
}

- (Boolean) ConfAllowLine :(int) nLineNo :(Boolean) bAllowListen :(Boolean) bAllowSpeak;
{
    return [mAgentFrwSIP ConfAllowLine :nLineNo: bAllowListen: bAllowSpeak];
}

- (Boolean) LineVoiceChannelSpk :(int) nLineNo :(int) nChannel;
{
    return [mAgentFrwSIP LineVoiceChannelSpk :nLineNo: nChannel];
}

- (Boolean) ChatFindContact :(NSString*) sAccountName :(NSString*) sUserName;
{
    return [mAgentFrwSIP ChatFindContact :sAccountName :sUserName];
}

- (Boolean) ChatAddContact :(NSString*) sAccountName :(NSString*) sUserName :(Boolean) bPresence;
{
    return [mAgentFrwSIP ChatAddContact :sAccountName :sUserName :bPresence];
}

- (Boolean) ChatRemoveContact :(NSString*) sAccountName :(NSString*) sUserName;
{
    return [mAgentFrwSIP ChatRemoveContact :sAccountName :sUserName];
}
    
- (Boolean) ChatSendMessageTyping :(NSString*) sAccountName :(NSString*) sUserName :(long) nUserValue;
{
    return [mAgentFrwSIP ChatSendMessageTyping :sAccountName :sUserName :nUserValue];
}

- (Boolean) ChatSendMessageText :(NSString*) sAccountName :(NSString*) sUserName :(NSString*) sMsgText :(Boolean) bMsgTypeHtml :(long) nUserValue;
{
    return [mAgentFrwSIP ChatSendMessageText :sAccountName :sUserName :sMsgText :bMsgTypeHtml: nUserValue];
}

- (Boolean) ChatSubscribeContactAll :(NSString*) sAccountName;
{
    return [mAgentFrwSIP ChatSubscribeContactAll :sAccountName];
}

- (Boolean) ChatSetMyStatus :(NSString*) sAccountName :(int) nStatusId;
{
    return [mAgentFrwSIP ChatSetMyStatus :sAccountName :nStatusId];
}

- (Boolean) VoiceChanger :(int) nPitch;
{
    return [mAgentFrwSIP VoiceChanger :nPitch];
}

- (Boolean) ForwardCall :(Boolean) bEnable :(NSString*) sToUserName;
{
    return [mAgentFrwSIP ForwardCall :bEnable :sToUserName];
}

- (Boolean) PlayAddPCM :(int) nLineNo :(char*) pDataPCM :(int) nSizePCM;
{
    return [mAgentFrwSIP PlayAddPCM :nLineNo: pDataPCM: nSizePCM];
}

- (Boolean) PlayResetPCM :(int) nLineNo;
{
    return [mAgentFrwSIP PlayResetPCM :nLineNo];
}

- (Boolean) AddCustomHeader :(int) nLineNo :(int) nReqId :(NSString*) sName :(NSString*) sValue;
{
    return [mAgentFrwSIP AddCustomHeader :nLineNo: nReqId :sName :sValue];
}

- (Boolean) RemoveCustomHeader :(int) nLineNo :(int) nReqId :(NSString*) sName;
{
    return [mAgentFrwSIP RemoveCustomHeader :nLineNo: nReqId :sName];
}

- (Boolean) RemoveCustomHeaderAll :(int) nLineNo :(int) nReqId;
{
    return [mAgentFrwSIP RemoveCustomHeaderAll :nLineNo: nReqId];
}

- (Boolean) AddCustomHeaderReferToURI :(NSString*) sName :(NSString*) sValue;
{
    return [mAgentFrwSIP AddCustomHeaderReferToURI :sName :sValue];
}

- (Boolean) RemoveCustomHeaderReferToURI :(NSString*) sName;
{
    return [mAgentFrwSIP RemoveCustomHeaderReferToURI :sName];
}

- (Boolean) RemoveCustomHeaderAllReferToURI;
{
    return [mAgentFrwSIP RemoveCustomHeaderAllReferToURI];
}

- (int) GetCountPacketLost :(int) nLineNo;
{
    return [mAgentFrwSIP GetCountPacketLost :nLineNo];
}

- (int) GetSizeJitterBuffer :(int) nLineNo;
{
    return [mAgentFrwSIP GetSizeJitterBuffer :nLineNo];
}

- (int) GetVideoDevTotal;
{
    return [mAgentFrwSIP GetVideoDevTotal];
}

- (NSString*) GetVideoDevName :(int) nDeviceId;
{
    return [mAgentFrwSIP GetVideoDevName :nDeviceId];
}

- (Boolean) OpenVideoDev :(int) nDeviceId :(int) nQuality;
{
    return [mAgentFrwSIP OpenVideoDev :nDeviceId: nQuality];
}

- (void) CloseVideoDev;
{
    [mAgentFrwSIP CloseVideoDev];
}

////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////

- (Boolean) DialRingEnable :(NSString*) sFileName;
{
    return [mAgentFrwSIP DialRingEnable :sFileName];
}

- (Boolean) DialRingDisable;
{
    return [mAgentFrwSIP DialRingDisable];
}

- (Boolean) BusyRingEnable :(NSString*) sFileName;
{
    return [mAgentFrwSIP BusyRingEnable :sFileName];
}

- (Boolean) BusyRingDisable;
{
    return [mAgentFrwSIP BusyRingDisable];
}

- (Boolean) EnableVideo :(int) nLineNo :(Boolean) bOutbound :(Boolean) bInbound;
{
    return [mAgentFrwSIP EnableVideo :nLineNo: bOutbound: bInbound];
}

- (Boolean) IsNetworkAvailable;
{
    return [mAgentFrwSIP IsNetworkAvailable];
}

- (Boolean) NetworkReachability :(Boolean) bEnable;
{
    return [mAgentFrwSIP NetworkReachability :bEnable];
}

- (Boolean) AutoRegistration :(NSString*) sAccountName :(Boolean) bEnable :(int) nTickCountLimit :(int) nTickSeconds;
{
    return [mAgentFrwSIP AutoRegistration :sAccountName :bEnable: nTickCountLimit: nTickSeconds];
}

- (Boolean) VideoCodecBitRate :(int) nCodecNo :(int) nQuality;
{
    return [mAgentFrwSIP VideoCodecBitRate :nCodecNo: nQuality];
}

- (int) BusyLampGetContactStatus :(NSString*) sAccountName :(NSString*) sUserName;
{
    return [mAgentFrwSIP BusyLampGetContactStatus :sAccountName :sUserName];
}

- (Boolean) BusyLampFindContact :(NSString*) sAccountName :(NSString*) sUserName;
{
    return [mAgentFrwSIP BusyLampFindContact :sAccountName :sUserName];
}

- (Boolean) BusyLampAddContact :(NSString*) sAccountName :(NSString*) sUserName;
{
    return [mAgentFrwSIP BusyLampAddContact :sAccountName :sUserName];
}

- (Boolean) BusyLampRemoveContact :(NSString*) sAccountName :(NSString*) sUserName;
{
    return [mAgentFrwSIP BusyLampRemoveContact :sAccountName :sUserName];
}

- (Boolean) BusyLampSubscribeContactAll :(NSString*) sAccountName;
{
    return [mAgentFrwSIP BusyLampSubscribeContactAll :sAccountName];
}

/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////

- (Boolean) DiagnosticLogSIP :(NSString*) sAccountName :(Boolean) bInbound :(Boolean) bOutbound;
{
    return [mAgentFrwSIP DiagnosticLogSIP :sAccountName :bInbound: bOutbound];
}

- (Boolean) SetPushSIP :(NSString*) sAccountName :(NSString*) sTeamID :(NSString*) sBundleID :(NSString*) sDeviceToken;
{
    return [mAgentFrwSIP SetPushSIP :sAccountName :sTeamID :sBundleID :sDeviceToken];
}

- (Boolean) AudioVAD :(int) nLineNo :(Boolean) bEnable;
{
    return [mAgentFrwSIP AudioVAD :nLineNo :bEnable];
}

- (Boolean) SetNetworkPrioritySIP :(int) nMode;
{
    return [mAgentFrwSIP SetNetworkPrioritySIP :nMode];
}

/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////

+ (void) OnInitialized;
{
    for (id <iVaxUserAgentSIP> vDelegate in mListDelegate)
    {
        if (![vDelegate respondsToSelector:@selector(OnInitialized)])
            continue;
    
        [vDelegate OnInitialized];
    }
}

+ (void) OnUnInitialized;
{
    for (id <iVaxUserAgentSIP> vDelegate in mListDelegate)
    {
        if (![vDelegate respondsToSelector:@selector(OnUnInitialized)])
            continue;
    
        [vDelegate OnUnInitialized];
    }
}

+ (void) OnConnectingToRegister :(NSString*) sAccountName;
{
    for (id <iVaxUserAgentSIP> vDelegate in mListDelegate)
    {
        if (![vDelegate respondsToSelector:@selector(OnConnectingToRegister:)])
            continue;
    
        [vDelegate OnConnectingToRegister :sAccountName];
    }
}

+ (void) OnTryingToRegister :(NSString*) sAccountName;
{
    for (id <iVaxUserAgentSIP> vDelegate in mListDelegate)
    {
        if (![vDelegate respondsToSelector:@selector(OnTryingToRegister:)])
            continue;
    
        [vDelegate OnTryingToRegister :sAccountName];
    }
}

+ (void) OnFailToRegister :(NSString*) sAccountName :(int) nStatusCode :(NSString*) sReasonPhrase;
{
    for (id <iVaxUserAgentSIP> vDelegate in mListDelegate)
    {
        if (![vDelegate respondsToSelector:@selector(OnFailToRegister:::)])
            continue;
    
        [vDelegate OnFailToRegister :sAccountName :nStatusCode :sReasonPhrase];
    }
}

+ (void) OnSuccessToRegister :(NSString*) sAccountName;
{
    for (id <iVaxUserAgentSIP> vDelegate in mListDelegate)
    {
        if (![vDelegate respondsToSelector:@selector(OnSuccessToRegister:)])
            continue;
    
        [vDelegate OnSuccessToRegister :sAccountName];
    }
}

+ (void) OnConnectingToReRegister :(NSString*) sAccountName;
{
    for (id <iVaxUserAgentSIP> vDelegate in mListDelegate)
    {
        if (![vDelegate respondsToSelector:@selector(OnConnectingToReRegister:)])
            continue;
    
        [vDelegate OnConnectingToReRegister :sAccountName];
    }
}

+ (void) OnTryingToReRegister :(NSString*) sAccountName;
{
    for (id <iVaxUserAgentSIP> vDelegate in mListDelegate)
    {
        if (![vDelegate respondsToSelector:@selector(OnTryingToReRegister:)])
            continue;
    
        [vDelegate OnTryingToReRegister :sAccountName];
    }
}

+ (void) OnFailToReRegister :(NSString*) sAccountName :(int) nStatusCode :(NSString*) sReasonPhrase;
{
    for (id <iVaxUserAgentSIP> vDelegate in mListDelegate)
    {
        if (![vDelegate respondsToSelector:@selector(OnFailToReRegister:::)])
            continue;
    
        [vDelegate OnFailToReRegister :sAccountName :nStatusCode :sReasonPhrase];
    }
}

+ (void) OnSuccessToReRegister :(NSString*) sAccountName;
{
    for (id <iVaxUserAgentSIP> vDelegate in mListDelegate)
    {
        if (![vDelegate respondsToSelector:@selector(OnSuccessToReRegister:)])
            continue;
    
        [vDelegate OnSuccessToReRegister :sAccountName];
    }
}
    
+ (void) OnTryingToUnRegister :(NSString*) sAccountName;
{
    for (id <iVaxUserAgentSIP> vDelegate in mListDelegate)
    {
        if (![vDelegate respondsToSelector:@selector(OnTryingToUnRegister:)])
            continue;
    
        [vDelegate OnTryingToUnRegister :sAccountName];
    }
}

+ (void) OnFailToUnRegister :(NSString*) sAccountName;
{
    for (id <iVaxUserAgentSIP> vDelegate in mListDelegate)
    {
        if (![vDelegate respondsToSelector:@selector(OnFailToUnRegister:)])
            continue;
    
        [vDelegate OnFailToUnRegister :sAccountName];
    }
}

+ (void) OnSuccessToUnRegister :(NSString*) sAccountName;
{
    for (id <iVaxUserAgentSIP> vDelegate in mListDelegate)
    {
        if (![vDelegate respondsToSelector:@selector(OnSuccessToUnRegister:)])
            continue;
    
        [vDelegate OnSuccessToUnRegister :sAccountName];
    }
}
        
/////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////

+ (void) OnDialCallStarted :(NSString*) sAccountName :(int) nLineNo :(NSString*) sCallerName :(NSString*) sCallerId :(NSString*) sDialNo;
{
    for (id <iVaxUserAgentSIP> vDelegate in mListDelegate)
    {
        if (![vDelegate respondsToSelector:@selector(OnDialCallStarted:::::)])
            continue;
    
        [vDelegate OnDialCallStarted :sAccountName :nLineNo :sCallerName :sCallerId :sDialNo];
    }
}

+ (void) OnDialingCall :(NSString*) sAccountName :(int) nLineNo :(int) nStatusCode :(NSString*) sReasonPhrase;
{
    for (id <iVaxUserAgentSIP> vDelegate in mListDelegate)
    {
        if (![vDelegate respondsToSelector:@selector(OnDialingCall::::)])
            continue;
    
        [vDelegate OnDialingCall :sAccountName :nLineNo :nStatusCode :sReasonPhrase];
    }
}

+ (void) OnDialCallFailed :(NSString*) sAccountName :(int) nLineNo :(int) nStatusCode :(NSString*) sReasonPhrase :(NSString*) sContact;
{
    for (id <iVaxUserAgentSIP> vDelegate in mListDelegate)
    {
        if (![vDelegate respondsToSelector:@selector(OnDialCallFailed:::::)])
            continue;
    
        [vDelegate OnDialCallFailed :sAccountName :nLineNo :nStatusCode :sReasonPhrase :sContact];
    }
}

+ (void) OnConnectedCall :(NSString*) sAccountName :(int) nLineNo :(NSString*) sToAddrRTP :(int) nToPortRTP;
{
    for (id <iVaxUserAgentSIP> vDelegate in mListDelegate)
    {
        if (![vDelegate respondsToSelector:@selector(OnConnectedCall::)])
            continue;
    
        [vDelegate OnConnectedCall :sAccountName :nLineNo];
    }
}

+ (void) OnHungupCall :(NSString*) sAccountName :(int) nLineNo;
{
    for (id <iVaxUserAgentSIP> vDelegate in mListDelegate)
    {
        if (![vDelegate respondsToSelector:@selector(OnHungupCall::)])
            continue;
    
        [vDelegate OnHungupCall :sAccountName :nLineNo];
    }
}

+ (void) OnDisconnectedCall :(int) nLineNo;
{
    for (id <iVaxUserAgentSIP> vDelegate in mListDelegate)
    {
        if (![vDelegate respondsToSelector:@selector(OnDisconnectedCall:)])
            continue;
    
        [vDelegate OnDisconnectedCall :nLineNo];
    }
}

+ (void) OnIncomingCallStarted :(NSString*) sAccountName :(NSString*) sCallId :(NSString*) sCallerName :(NSString*) sCallerId :(NSString*) sDialNo :(NSString*) sFromURI :(NSString*) sToURI;
{
    NSMutableString* sResultCallerName = [NSMutableString new];
    NSMutableString* sResultCallerId = [NSMutableString new];
    NSMutableString* sResultContactId = [NSMutableString new];
    
    [cVaxCallInfo PrepareInfo :sCallerName :sCallerId :&sResultCallerName :&sResultCallerId :&sResultContactId];
    
    for (id <iVaxUserAgentSIP> vDelegate in mListDelegate)
    {
        if (![vDelegate respondsToSelector:@selector(OnIncomingCallStarted:::)])
            continue;
    
        [vDelegate OnIncomingCallStarted :sAccountName :sResultCallerName :sResultCallerId];
    }
}

+ (void) OnIncomingCallEnded :(NSString*) sAccountName :(NSString*) sCallId :(int) nReasonCode;
{
    for (id <iVaxUserAgentSIP> vDelegate in mListDelegate)
    {
        if (![vDelegate respondsToSelector:@selector(OnIncomingCallEnded::)])
            continue;
    
        [vDelegate OnIncomingCallEnded :sAccountName :nReasonCode];
    }
}
    
/////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////

+ (void) OnTransferCallFailed :(NSString*) sAccountName :(int) nLineNo :(int) nStatusCode :(NSString*) sReasonPhrase;
{
    for (id <iVaxUserAgentSIP> vDelegate in mListDelegate)
    {
        if (![vDelegate respondsToSelector:@selector(OnTransferCallFailed::::)])
            continue;
    
        [vDelegate OnTransferCallFailed :sAccountName :nLineNo :nStatusCode :sReasonPhrase];
    }
}

+ (void) OnTransferCallAccepted :(NSString*) sAccountName :(int) nLineNo;
{
    for (id <iVaxUserAgentSIP> vDelegate in mListDelegate)
    {
        if (![vDelegate respondsToSelector:@selector(OnTransferCallAccepted::)])
            continue;
    
        [vDelegate OnTransferCallAccepted :sAccountName :nLineNo];
    }
}

/////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////

+ (void) OnPlayWaveDone :(NSString*) sAccountName :(int) nLineNo;
{
    for (id <iVaxUserAgentSIP> vDelegate in mListDelegate)
    {
        if (![vDelegate respondsToSelector:@selector(OnPlayWaveDone::)])
            continue;
    
        [vDelegate OnPlayWaveDone :sAccountName :nLineNo];
    }
}

+ (void) OnDigitDTMF :(NSString*) sAccountName :(int) nLineNo :(NSString*) sDigit;
{
    for (id <iVaxUserAgentSIP> vDelegate in mListDelegate)
    {
        if (![vDelegate respondsToSelector:@selector(OnDigitDTMF:::)])
            continue;
    
        [vDelegate OnDigitDTMF :sAccountName :nLineNo :sDigit];
    }
}
    
+ (void) OnMsgNOTIFY :(NSString*) sAccountName :(NSString*) sMsg;
{
    for (id <iVaxUserAgentSIP> vDelegate in mListDelegate)
    {
        if (![vDelegate respondsToSelector:@selector(OnMsgNOTIFY::)])
            continue;
    
        [vDelegate OnMsgNOTIFY :sAccountName :sMsg];
    }
}

/////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////

+ (void) OnVoiceMailMsg :(NSString*) sAccountName :(Boolean) bIsMsgWaiting :(int) nNewMsgCount :(int) nOldMsgCount :(int) nNewUrgentMsgCount :(int) nOldUrgentMsgCount :(NSString*) sMsgAccount;
{
    for (id <iVaxUserAgentSIP> vDelegate in mListDelegate)
    {
        if (![vDelegate respondsToSelector:@selector(OnVoiceMailMsg:::::::)])
            continue;
    
        [vDelegate OnVoiceMailMsg :sAccountName :bIsMsgWaiting :nNewMsgCount :nOldMsgCount :nNewUrgentMsgCount :nOldUrgentMsgCount :sMsgAccount];
    }
}

/////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////

+ (void) OnRingToneStarted :(NSString*) sAccountName :(NSString*) sCallId;
{
    for (id <iVaxUserAgentSIP> vDelegate in mListDelegate)
    {
        if (![vDelegate respondsToSelector:@selector(OnRingToneStarted:)])
            continue;
    
        [vDelegate OnRingToneStarted :sAccountName];
    }
}

+ (void) OnRingToneEnded :(NSString*) sAccountName :(NSString*) sCallId;
{
    for (id <iVaxUserAgentSIP> vDelegate in mListDelegate)
    {
        if (![vDelegate respondsToSelector:@selector(OnRingToneEnded:)])
            continue;
    
        [vDelegate OnRingToneEnded :sAccountName];
    }
}

/////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////

+ (void) OnIncomingDiagnostic :(NSString*) sAccountName :(NSString*) sMsgSIP :(NSString*) sFromIP :(int) nFromPort;
{
    for (id <iVaxUserAgentSIP> vDelegate in mListDelegate)
    {
        if (![vDelegate respondsToSelector:@selector(OnIncomingDiagnostic::::)])
            continue;
    
        [vDelegate OnIncomingDiagnostic :sAccountName :sMsgSIP :sFromIP :nFromPort];
    }
}

+ (void) OnOutgoingDiagnostic :(NSString*) sAccountName :(NSString*) sMsgSIP :(NSString*) sToIP :(int) nToPort;
{
    for (id <iVaxUserAgentSIP> vDelegate in mListDelegate)
    {
        if (![vDelegate respondsToSelector:@selector(OnOutgoingDiagnostic::::)])
            continue;
    
        [vDelegate OnOutgoingDiagnostic :sAccountName :sMsgSIP :sToIP :nToPort];
    }
}

/////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////

+ (void) OnAudioSessionLost :(NSString*) sAccountName :(int) nLineNo;
{
    for (id <iVaxUserAgentSIP> vDelegate in mListDelegate)
    {
        if (![vDelegate respondsToSelector:@selector(OnAudioSessionLost::)])
            continue;
    
        [vDelegate OnAudioSessionLost :sAccountName :nLineNo];
    }
}

/////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////

+ (void) OnSuccessToHold :(NSString*) sAccountName :(int) nLineNo;
{
    for (id <iVaxUserAgentSIP> vDelegate in mListDelegate)
    {
        if (![vDelegate respondsToSelector:@selector(OnSuccessToHold::)])
            continue;
    
        [vDelegate OnSuccessToHold :sAccountName :nLineNo];
    }
}

+ (void) OnTryingToHold :(NSString*) sAccountName :(int) nLineNo;
{
    for (id <iVaxUserAgentSIP> vDelegate in mListDelegate)
    {
        if (![vDelegate respondsToSelector:@selector(OnTryingToHold::)])
            continue;
    
        [vDelegate OnTryingToHold :sAccountName :nLineNo];
    }
}

+ (void) OnFailToHold :(NSString*) sAccountName :(int) nLineNo;
{
    for (id <iVaxUserAgentSIP> vDelegate in mListDelegate)
    {
        if (![vDelegate respondsToSelector:@selector(OnFailToHold::)])
            continue;
    
        [vDelegate OnFailToHold :sAccountName :nLineNo];
    }
}

/////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////

+ (void) OnSuccessToUnHold :(NSString*) sAccountName :(int) nLineNo;
{
     for (id <iVaxUserAgentSIP> vDelegate in mListDelegate)
     {
        if (![vDelegate respondsToSelector:@selector(OnSuccessToUnHold::)])
            continue;
    
        [vDelegate OnSuccessToUnHold :sAccountName :nLineNo];
    }
}

+ (void) OnTryingToUnHold :(NSString*) sAccountName :(int) nLineNo;
{
    for (id <iVaxUserAgentSIP> vDelegate in mListDelegate)
    {
        if (![vDelegate respondsToSelector:@selector(OnTryingToUnHold::)])
            continue;
    
        [vDelegate OnTryingToUnHold :sAccountName :nLineNo];
    }
}

+ (void) OnFailToUnHold :(NSString*) sAccountName :(int) nLineNo;
{
    for (id <iVaxUserAgentSIP> vDelegate in mListDelegate)
    {
        if (![vDelegate respondsToSelector:@selector(OnFailToUnHold::)])
            continue;
    
        [vDelegate OnFailToUnHold :sAccountName :nLineNo];
    }
}

/////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////

+ (void) OnTryingToRefresh :(NSString*) sAccountName :(int) nLineNo;
{
     for (id <iVaxUserAgentSIP> vDelegate in mListDelegate)
     {
        if (![vDelegate respondsToSelector:@selector(OnTryingToRefresh::)])
            continue;
    
        [vDelegate OnTryingToRefresh :sAccountName :nLineNo];
    }
}

+ (void) OnFailToRefresh :(NSString*) sAccountName :(int) nLineNo;
{
    for (id <iVaxUserAgentSIP> vDelegate in mListDelegate)
    {
        if (![vDelegate respondsToSelector:@selector(OnFailToRefresh::)])
            continue;
    
        [vDelegate OnFailToRefresh :sAccountName :nLineNo];
    }
}

+ (void) OnSuccessToRefresh :(NSString*) sAccountName :(int) nLineNo;
{
    for (id <iVaxUserAgentSIP> vDelegate in mListDelegate)
    {
        if (![vDelegate respondsToSelector:@selector(OnSuccessToRefresh::)])
            continue;
    
        [vDelegate OnSuccessToRefresh :sAccountName :nLineNo];
    }
}

/////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////

+ (void) OnChatSubscribeSuccess :(NSString*) sAccountName :(NSString*) sUserName;
{
    for (id <iVaxUserAgentSIP> vDelegate in mListDelegate)
    {
        if (![vDelegate respondsToSelector:@selector(OnChatSubscribeSuccess::)])
            continue;
    
        [vDelegate OnChatSubscribeSuccess :sAccountName :sUserName];
    }
}

+ (void) OnChatSubscribeFailed :(NSString*) sAccountName :(NSString*) sUserName :(int) nStatusCode :(NSString*) sReasonPhrase;
{
    for (id <iVaxUserAgentSIP> vDelegate in mListDelegate)
    {
        if (![vDelegate respondsToSelector:@selector(OnChatSubscribeFailed::::)])
            continue;
    
        [vDelegate OnChatSubscribeFailed :sAccountName :sUserName :nStatusCode :sReasonPhrase];
    }
}

+ (void) OnChatContactStatus :(NSString*) sAccountName :(NSString*) sUserName :(int) nStatusId;
{
    for (id <iVaxUserAgentSIP> vDelegate in mListDelegate)
    {
        if (![vDelegate respondsToSelector:@selector(OnChatContactStatus:::)])
            continue;
    
        [vDelegate OnChatContactStatus :sAccountName :sUserName :nStatusId];
    }
}
        
+ (void) OnChatSendMsgTextSuccess :(NSString*) sAccountName :(NSString*) sUserName :(NSString*) sMsgText :(long) nUserValue;
{
    for (id <iVaxUserAgentSIP> vDelegate in mListDelegate)
    {
        if (![vDelegate respondsToSelector:@selector(OnChatSendMsgTextSuccess::::)])
            continue;
    
        [vDelegate OnChatSendMsgTextSuccess :sAccountName :sUserName :sMsgText :nUserValue];
    }
}

+ (void) OnChatSendMsgTextFailed :(NSString*) sAccountName :(NSString*) sUserName :(int) nStatusCode :(NSString*) sReasonPhrase :(NSString*) sMsgText :(long) nUserValue;
{
    for (id <iVaxUserAgentSIP> vDelegate in mListDelegate)
    {
        if (![vDelegate respondsToSelector:@selector(OnChatSendMsgTextFailed::::::)])
            continue;
    
        [vDelegate OnChatSendMsgTextFailed :sAccountName :sUserName :nStatusCode :sReasonPhrase :sMsgText :nUserValue];
    }
}
    
+ (void) OnChatSendMsgTypingSuccess :(NSString*) sAccountName :(NSString*) sUserName :(long) nUserValue;
{
    for (id <iVaxUserAgentSIP> vDelegate in mListDelegate)
    {
        if (![vDelegate respondsToSelector:@selector(OnChatSendMsgTypingSuccess:::)])
            continue;
    
        [vDelegate OnChatSendMsgTypingSuccess :sAccountName :sUserName :nUserValue];
    }
}

+ (void) OnChatSendMsgTypingFailed :(NSString*) sAccountName :(NSString*) sUserName :(int) nStatusCode :(NSString*) sReasonPhrase :(long) nUserValue;
{
    for (id <iVaxUserAgentSIP> vDelegate in mListDelegate)
    {
        if (![vDelegate respondsToSelector:@selector(OnChatSendMsgTypingFailed:::::)])
            continue;
    
        [vDelegate OnChatSendMsgTypingFailed :sAccountName :sUserName :nStatusCode :sReasonPhrase :nUserValue];
    }
}

+ (void) OnChatRecvMsgText :(NSString*) sAccountName :(NSString*) sUserName :(NSString*) sMsgText :(Boolean) bIsChatContact;
{
    for (id <iVaxUserAgentSIP> vDelegate in mListDelegate)
    {
        if (![vDelegate respondsToSelector:@selector(OnChatRecvMsgText::::)])
            continue;
    
        [vDelegate OnChatRecvMsgText :sAccountName :sUserName :sMsgText :bIsChatContact];
    }
}

+ (void) OnChatRecvMsgTypingStart :(NSString*) sAccountName :(NSString*) sUserName;
{
     for (id <iVaxUserAgentSIP> vDelegate in mListDelegate)
     {
        if (![vDelegate respondsToSelector:@selector(OnChatRecvMsgTypingStart::)])
            continue;
    
        [vDelegate OnChatRecvMsgTypingStart :sAccountName :sUserName];
    }
}

+ (void) OnChatRecvMsgTypingStop :(NSString*) sAccountName :(NSString*) sUserName;
{
     for (id <iVaxUserAgentSIP> vDelegate in mListDelegate)
     {
        if (![vDelegate respondsToSelector:@selector(OnChatRecvMsgTypingStop::)])
            continue;
    
        [vDelegate OnChatRecvMsgTypingStop :sAccountName :sUserName];
    }
}

/////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////

+ (void) OnAudioRecordedPCM :(NSString*) sAccountName :(int) nLineNo :(char*) pDataPCM :(int) nSizePCM :(int) nTypePCM;
{
    for (id <iVaxUserAgentSIP> vDelegate in mListDelegate)
    {
        if (![vDelegate respondsToSelector:@selector(OnAudioRecordedPCM:::::)])
            continue;
    
        [vDelegate OnAudioRecordedPCM :sAccountName :nLineNo :pDataPCM :nSizePCM :nTypePCM];
    }
}

/////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////

+ (void) OnHoldCall :(NSString*) sAccountName :(int) nLineNo;
{
    for (id <iVaxUserAgentSIP> vDelegate in mListDelegate)
    {
        if (![vDelegate respondsToSelector:@selector(OnHoldCall::)])
            continue;
    
        [vDelegate OnHoldCall :sAccountName :nLineNo];
    }
}

+ (void) OnUnHoldCall :(NSString*) sAccountName :(int) nLineNo;
{
    for (id <iVaxUserAgentSIP> vDelegate in mListDelegate)
    {
        if (![vDelegate respondsToSelector:@selector(OnUnHoldCall::)])
            continue;
    
        [vDelegate OnUnHoldCall :sAccountName :nLineNo];
    }
}

/////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////

+ (void) OnVideoRemoteStarted :(NSString*) sAccountName :(int) nLineNo;
{
    for (id <iVaxUserAgentSIP> vDelegate in mListDelegate)
    {
        if (![vDelegate respondsToSelector:@selector(OnVideoRemoteStarted::)])
            continue;
    
        [vDelegate OnVideoRemoteStarted :sAccountName :nLineNo];
    }
}

+ (void) OnVideoRemoteEnded :(NSString*) sAccountName :(int) nLineNo;
{
    for (id <iVaxUserAgentSIP> vDelegate in mListDelegate)
    {
        if (![vDelegate respondsToSelector:@selector(OnVideoRemoteEnded::)])
            continue;
    
        [vDelegate OnVideoRemoteEnded :sAccountName :nLineNo];
    }
}
    
+ (void) OnVideoDeviceFrameRGB :(int) nDeviceId :(char*) pFrameRGB :(int) nFrameSize :(int) nFrameWidth :(int) nFrameHeight;
{
    for (id <iVaxUserAgentSIP> vDelegate in mListDelegate)
    {
        if (![vDelegate respondsToSelector:@selector(OnVideoDeviceFrameRGB:::::)])
            continue;
    
        [vDelegate OnVideoDeviceFrameRGB :nDeviceId :pFrameRGB :nFrameSize :nFrameWidth :nFrameHeight];
    }
}

+ (void) OnVideoRemoteFrameRGB :(NSString*) sAccountName :(int) nLineNo :(char*) pFrameRGB :(int) nFrameSize :(int) nFrameWidth :(int) nFrameHeight;
{
    for (id <iVaxUserAgentSIP> vDelegate in mListDelegate)
    {
        if (![vDelegate respondsToSelector:@selector(OnVideoRemoteFrameRGB::::::)])
            continue;
    
        [vDelegate OnVideoRemoteFrameRGB :sAccountName :nLineNo :pFrameRGB :nFrameSize :nFrameWidth :nFrameHeight];
    }
}

/////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////

+ (void) OnAddCallHistory :(NSString*) sAccountName :(Boolean) bOutboundCallType :(NSString*) sCallerName :(NSString*) sCallerId :(NSString*) sDialNo :(long) nStartTime :(long) nEndTime :(long) nDuration :(long) nDayNo :(int) nHistoryTypeId;
{
    for (id <iVaxUserAgentSIP> vDelegate in mListDelegate)
    {
        if (![vDelegate respondsToSelector:@selector(OnAddCallHistory::::::::::)])
            continue;
    
        [vDelegate OnAddCallHistory :sAccountName :bOutboundCallType :sCallerName :sCallerId :sDialNo :nStartTime :nEndTime :nDuration :nDayNo :nHistoryTypeId];
    }
}

+ (void) OnNetworkReachability :(Boolean) bAvailable;
{
    for (id <iVaxUserAgentSIP> vDelegate in mListDelegate)
    {
        if (![vDelegate respondsToSelector:@selector(OnNetworkReachability:)])
            continue;
    
        [vDelegate OnNetworkReachability :bAvailable];
    }
}

/////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////

+ (void) OnAudioDeviceMicVU :(int) nLevelVU;
{
    for (id <iVaxUserAgentSIP> vDelegate in mListDelegate)
    {
        if (![vDelegate respondsToSelector:@selector(OnAudioDeviceMicVU:)])
            continue;
    
        [vDelegate OnAudioDeviceMicVU :nLevelVU];
    }
}

+ (void) OnAudioDeviceSpkVU :(int) nLevelVU;
{
    for (id <iVaxUserAgentSIP> vDelegate in mListDelegate)
    {
        if (![vDelegate respondsToSelector:@selector(OnAudioDeviceSpkVU:)])
            continue;
    
        [vDelegate OnAudioDeviceSpkVU :nLevelVU];
    }
}

/////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////

+ (void) OnBusyLampSubscribeSuccess :(NSString*) sAccountName :(NSString*) sUserName;
{
    for (id <iVaxUserAgentSIP> vDelegate in mListDelegate)
    {
        if (![vDelegate respondsToSelector:@selector(OnBusyLampSubscribeSuccess::)])
            continue;
    
        [vDelegate OnBusyLampSubscribeSuccess :sAccountName :sUserName];
    }
}

+ (void) OnBusyLampSubscribeFailed :(NSString*) sAccountName :(NSString*) sUserName :(int) nStatusCode :(NSString*) sReasonPhrase;
{
    for (id <iVaxUserAgentSIP> vDelegate in mListDelegate)
    {
        if (![vDelegate respondsToSelector:@selector(OnBusyLampSubscribeFailed::::)])
            continue;
    
        [vDelegate OnBusyLampSubscribeFailed :sAccountName :sUserName :nStatusCode :sReasonPhrase];
    }
}

+ (void) OnBusyLampContactStatus :(NSString*) sAccountName :(NSString*) sUserName :(int) nStatusId;
{
    for (id <iVaxUserAgentSIP> vDelegate in mListDelegate)
    {
        if (![vDelegate respondsToSelector:@selector(OnBusyLampContactStatus:::)])
            continue;
    
        [vDelegate OnBusyLampContactStatus :sAccountName :sUserName :nStatusId];
    }
}

/////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////

+ (void) OnVaxErrorMsg :(NSString*) sFuncName :(NSString*) sErrorMsg :(int) nErrorCode;
{
    for (id <iVaxUserAgentSIP> vDelegate in mListDelegate)
    {
        if (![vDelegate respondsToSelector:@selector(OnVaxErrorMsg:::)])
            continue;
    
        [vDelegate OnVaxErrorMsg :sFuncName :sErrorMsg :nErrorCode];
    }
}

/////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////

+ (void) OnVaxRegisterTryingPushKit;
{
    for (id <iVaxUserAgentSIP> vDelegate in mListDelegate)
    {
        if (![vDelegate respondsToSelector:@selector(OnVaxRegisterTryingPushKit)])
            continue;
    
        [vDelegate OnVaxRegisterTryingPushKit];
    }
}

+ (void) OnVaxRegisterFailedPushKit;
{
    for (id <iVaxUserAgentSIP> vDelegate in mListDelegate)
    {
        if (![vDelegate respondsToSelector:@selector(OnVaxRegisterFailedPushKit)])
            continue;
    
        [vDelegate OnVaxRegisterFailedPushKit];
    }
}

+ (void) OnVaxRegisterSuccessPushKit :(NSString*) sDeviceToken;
{
    for (id <iVaxUserAgentSIP> vDelegate in mListDelegate)
    {
        if (![vDelegate respondsToSelector:@selector(OnVaxRegisterSuccessPushKit:)])
            continue;
    
        [vDelegate OnVaxRegisterSuccessPushKit :sDeviceToken];
    }
}

+ (void) OnVaxNotificationPushKit :(NSString*) sCallerName :(NSString*) sCallerId;
{
    NSMutableString* sResultCallerName = [NSMutableString new];
    NSMutableString* sResultCallerId = [NSMutableString new];
    NSMutableString* sResultContactId = [NSMutableString new];
    
    [cVaxCallInfo PrepareInfo :sCallerName :sCallerId :&sResultCallerName :&sResultCallerId :&sResultContactId];
    
    for (id <iVaxUserAgentSIP> vDelegate in mListDelegate)
    {
        if (![vDelegate respondsToSelector:@selector(OnIncomingCallPushKit::)])
            continue;
    
        [vDelegate OnIncomingCallPushKit :sResultCallerName :sResultCallerId];
    }
}

/////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////

@end;

